SortGroupInformation = {};
local L = LibStub("AceLocale-3.0"):GetLocale("SortGroup")
SortGroup_Variable_CompactSave = {}

local SortGroup_Variable_frame = {};
SortGroup_Variable_frame = CreateFrame("Frame", "SortGroupPanel", InterfaceOptionsFramePanelContainer);
local SortGroup_Variable_framePage2_AdditionalSwitch = CreateFrame("Frame", "SortGroupPanelPage2_AdditionalSwitch", SortGroup_Variable_frame);
local SortGroup_Variable_framePage3_Options = CreateFrame("Frame", "SortGroupPanelPage2_Options", SortGroup_Variable_frame);
-- Main Frame

SortGroup_Variable_GroupTop = true;
SortGroup_Variable_GroupBottom = false;
SortGroup_Variable_GroupTopDownwards = true;
SortGroup_Variable_GroupTopUpwards = false;
SortGroup_Variable_GroupBottomDownwards = false;
SortGroup_Variable_GroupBottomUpwards = false;
SortGroup_Variable_RegardlessRaidProfile = false;
SortGroup_Variable_GroupAutoActivate = true;
SortGroup_Variable_raidProfile = nil;

SortGroup_Variable_Page2_AdditionalSwitchActive = false;
SortGroup_Variable_Page2_AdditionalSwitchraidProfile = nil;
SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved = nil;
SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter = 0;
SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = {};
SortGroup_Variable_Page2_AdditionalSwitchArray = {};
SortGroup_Variable_Page2_AdditionalSwitchraidProfilOnThatPlace = "";

SortGroup_Variable_Page3_chatMessagesOn = true;
SortGroup_Variable_Page3_chatMessagesCurrentOptions = true;
SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch = true;
SortGroup_Variable_Page3_ChatMessagesWarnings = true;
SortGroup_Variable_Page3_ChangesInCombat = false;
SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = false;
SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility = true;
SortGroup_Variable_Page3_RaidProfilesSwitchInCombat = true;
-- SortGroup_Variable_cacheAutoActive intern cache for AutoActivate
-- Page2_AdditionalSwitchddmSavedProfiles count, necessary for deleting
-- SortGroup_Variable_Page2_AdditionalSwitchraidProfilOnThatPlace, changeOwnElemnt = false -> RaidProfile

SortGroup_Variable_Page3_Options_DebugMode = false;
SortGroup_Variable_Page3_Options_DebugModeLevel1 = false;
SortGroup_Variable_Page3_Options_DebugModeLevel2 = false;
SortGroup_Variable_Page3_Options_DebugModeLevel3 = false;
SortGroup_Variable_debuglevel = 0;
-- debugging, false = deactivated
-- 1 Options
-- 2 Events+Method Names
-- 4 Methods content
-- combinable
--- Saved Variables, default values

--SortGroup_Variable_cacheAutoActive = nil;
SortGroup_Variable_debugLevelCache = nil;
SortGroup_Variable_debugMethodNameCache = nil;
SortGroup_Variable_debugMethodContentCache = nil;
SortGroup_Variable_debugMethodNamePrint = true;

SortGroup_Variable_showChatMessage = false;
-- true when "PLAYER_ENTERING_WORLD" fired or cb Event gets triggered
-- so intern cache, for messages not getting displayed all the time

SortGroup_Variable_inCombat = false;
-- true when "PLAYER_REGEN_DISABLED" fired

SortGroup_Variable_raidProfilOnLoadIndex = 0;

SortGroup_Variable_playerChangeRaidProfileIntern = false;
-- true if player change Raid Profile


--local manager = CompactRaidFrameManager;

local fontFrame = SortGroup_Variable_frame:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
local fontFramePage2_AdditionalSwitch = SortGroup_Variable_framePage2_AdditionalSwitch:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
local fontFramePage3_Options = SortGroup_Variable_framePage3_Options:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");

local textVersion = CreateFrame("SimpleHTML", "textVersion_Text", SortGroup_Variable_frame);
local textAuthor = CreateFrame("SimpleHTML", "textAuthor_Text", SortGroup_Variable_frame); 
local versionNumber = "3.5.01";
local version = "|cFF00FF00Version|r  " .. versionNumber
local authorName = "Collabo93"
local author = "|cFF00FF00Author|r   " .. authorName

local Page2_AdditionalSwitchTextFrom = CreateFrame("SimpleHTML", "Page2_AdditionalSwitchTextFrom_Text", SortGroup_Variable_framePage2_AdditionalSwitch);
local Page2_AdditionalSwitchTextTo = CreateFrame("SimpleHTML", "Page2_AdditionalSwitch_AdditionalSwitchTextTo_Text", SortGroup_Variable_framePage2_AdditionalSwitch);
local Page2_AdditionalSwitchAvailableText = CreateFrame("SimpleHTML", "Page2_AvailableText_Text", SortGroup_Variable_framePage2_AdditionalSwitch);
local Page2_AdditionalSwitchSavedText = CreateFrame("SimpleHTML", "Page2_AdditionalSwitch_AvailableText_Text", SortGroup_Variable_framePage2_AdditionalSwitch);

	
local framePage3_Options_NormalText = CreateFrame("SimpleHTML", "framePage3_Options_NormalText_Text", SortGroup_Variable_framePage3_Options);
local framePage3_Options_CriticalText = CreateFrame("SimpleHTML", "framePage3_Options_NormalText_Text", SortGroup_Variable_framePage3_Options);
-- Text

local cBTop = CreateFrame("CheckButton", "CheckButtonTop_Text", SortGroup_Variable_frame, "UICheckButtonTemplate");
local cBBottom = CreateFrame("CheckButton", "CheckButtonBottom_Text", SortGroup_Variable_frame, "UICheckButtonTemplate");
local cbTopDownwards = CreateFrame("CheckButton", "CheckButtonTopDownwards_Text", cBTop, "UICheckButtonTemplate");
local cbTopUpwards = CreateFrame("CheckButton", "CheckButtonTopUpwards_Text", cBTop, "UICheckButtonTemplate");
local cbBottomDownwards = CreateFrame("CheckButton", "CheckButtonBottomDownwards_Text", cBBottom, "UICheckButtonTemplate");
local cbBottomUpwards = CreateFrame("CheckButton", "CheckButtonBottomUpwards_Text", cBBottom, "UICheckButtonTemplate");
local cbRegardlessRaidProfile = CreateFrame("CheckButton", "CheckButtonRegardlessRaidProfile_Text", SortGroup_Variable_frame, "UICheckButtonTemplate");
local cbAutoActivate = CreateFrame("CheckButton", "CheckButtonAutoActivate_Text", cbRegardlessRaidProfile, "UICheckButtonTemplate");

local Page2_AdditionalSwitchcbActive = CreateFrame("CheckButton", "CheckButtonPage2_AdditionalSwitchActive_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "UICheckButtonTemplate");

local Page3_cbChatMessagesOn = CreateFrame("CheckButton", "CheckButtonChatMessagesOn_Text", SortGroup_Variable_framePage3_Options, "UICheckButtonTemplate");
local Page3_cbChatMessagesCurrentOptions = CreateFrame("CheckButton", "CheckButtonChatMessagessCurrentOptions_Text", Page3_cbChatMessagesOn, "UICheckButtonTemplate");
local Page3_cbChatMessagesRaidProfileSwitch = CreateFrame("CheckButton", "CheckButtonChatMessagesRaidProfileSwitch_Text", Page3_cbChatMessagesOn, "UICheckButtonTemplate");
local Page3_cbChatMessagesWarnings = CreateFrame("CheckButton", "CheckButtonChatMessagesWarnings_Text", Page3_cbChatMessagesOn, "UICheckButtonTemplate");
local Page3_cbRaidProfilesUpdateInCombat = CreateFrame("CheckButton", "CheckButtonRaidProfilesUpdateInCombat_Text", SortGroup_Variable_framePage3_Options, "UICheckButtonTemplate");
local Page3_cbRaidProfilesUpdateInCombatVisibility = CreateFrame("CheckButton", "CheckButtonRaidProfilesUpdateInCombatVisibility_Text", Page3_cbRaidProfilesUpdateInCombat, "UICheckButtonTemplate");
local Page3_cbRaidProfilesSwitchInCombat = CreateFrame("CheckButton", "CheckButtonRaidProfilesSwitchInCombat_Text", SortGroup_Variable_framePage3_Options, "UICheckButtonTemplate");
local Page3_cbChangesInCombat = CreateFrame("CheckButton", "CheckButtonChangesInCombat_Text", SortGroup_Variable_framePage3_Options, "UICheckButtonTemplate");
local Page3_cbDebugMode = CreateFrame("CheckButton", "CheckButtonDebugMode_Text", SortGroup_Variable_framePage3_Options, "UICheckButtonTemplate");
local Page3_cbDebugModeLevel1 = CreateFrame("CheckButton", "CheckButtonDebugLevel1Mode_Text", Page3_cbDebugMode, "UICheckButtonTemplate");
local Page3_cbDebugModeLevel2 = CreateFrame("CheckButton", "CheckButtonDebugLevel2Mode_Text", Page3_cbDebugMode, "UICheckButtonTemplate");
local Page3_cbDebugModeLevel3 = CreateFrame("CheckButton", "CheckButtonDebugLevel3Mode_Text", Page3_cbDebugMode, "UICheckButtonTemplate");
-- Combo-box Options

local Page2_AdditionalSwitchbtnSave = CreateFrame("Button", "Page2_AdditionalSwitchbtnSave_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "UIPanelButtonTemplate");
local Page2_AdditionalSwitchbtnDelete = CreateFrame("Button", "Page2_AdditionalSwitchbtnDelete_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "UIPanelButtonTemplate");
local Page2_AdditionalSwitchbtnReset = CreateFrame("Button", "Page2_AdditionalSwitchbtnReset_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "UIPanelButtonTemplate");

local Page3_OptionsbtnReload = CreateFrame("Button", "page3btnReload_Text", SortGroup_Variable_framePage3_Options, "UIPanelButtonTemplate");
-- Button

local ddmProfiles = CreateFrame("Button", "DropDownMenuProfiles", cbAutoActivate, "UIDropDownMenuTemplate");
local Page2_AdditionalSwitchddmProfiles = CreateFrame("Button", "DropDownMenuPage2_AdditionalSwitchProfiles", SortGroup_Variable_framePage2_AdditionalSwitch, "UIDropDownMenuTemplate");
local Page2_AdditionalSwitchddmSavedProfiles = CreateFrame("Button", "DropDownMenuPage2_AdditionalSwitchddmSavedProfiles", SortGroup_Variable_framePage2_AdditionalSwitch, "UIDropDownMenuTemplate");
SortGroup_Variable_ddmItems = {};
-- DropDownMenu

local Page2_AdditionalSwitchSliderMinimum = CreateFrame("Slider", "Page2_AdditionalSwitchSliderMinimum_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "OptionsSliderTemplate");
local Page2_AdditionalSwitchSliderMaximum = CreateFrame("Slider", "Page2_AdditionalSwitchSliderMaximum_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "OptionsSliderTemplate");
-- Sliders

local defaultColor = "#FFFFFF";
---End Variables




local function createFrame()	
	SortGroup_Method_Debug("createFrame", "", 2);
	SortGroup_Variable_frame.name = "SortGroup";
	fontFrame:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFrame:SetTextColor(1, 0.8, 0);
    fontFrame:SetPoint("TOPLEFT", 12, -18);
    fontFrame:SetText("SortGroup");
	
	SortGroup_Variable_frame.cancel = function(SortGroup_Variable_frame)
		SortGroup_Method_Debug("InterfaceOptionsFrameCancel", "", 2);
		SortGroup_Method_SendSortOptionToSortBy(false);
	end
	SortGroup_Variable_frame.okay = function(SortGroup_Variable_frame)
		SortGroup_Method_Debug("InterfaceOptionsFrameOkay", "", 2);
		SortGroup_Method_SendSortOptionToSortBy(true);
	end
	InterfaceOptions_AddCategory(SortGroup_Variable_frame);
	
	SortGroup_Variable_framePage2_AdditionalSwitch.name = L["framePage2_AdditionalSwitch_Name"];
	fontFramePage2_AdditionalSwitch:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFramePage2_AdditionalSwitch:SetTextColor(1, 0.8, 0);
    fontFramePage2_AdditionalSwitch:SetPoint("TOPLEFT", 12, -18);
    fontFramePage2_AdditionalSwitch:SetText(L["framePage2_AdditionalSwitch_description"].."|r");
	SortGroup_Variable_framePage2_AdditionalSwitch.parent = SortGroup_Variable_frame.name;
	InterfaceOptions_AddCategory(SortGroup_Variable_framePage2_AdditionalSwitch);
	
	SortGroup_Variable_framePage3_Options.name = L["fontFramePage3_Options_Name"];
	fontFramePage3_Options:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFramePage3_Options:SetTextColor(1, 0.8, 0);
    fontFramePage3_Options:SetPoint("TOPLEFT", 12, -18);
    fontFramePage3_Options:SetText(L["fontFramePage3_Options_Name"].."|r");
	SortGroup_Variable_framePage3_Options.parent = SortGroup_Variable_frame.name;
	InterfaceOptions_AddCategory(SortGroup_Variable_framePage3_Options);
end

local function createText()
	SortGroup_Method_Debug("createText", "", 2);
	
	textVersion:SetPoint("TOPLEFT", 20, -45);
	textVersion:SetFontObject(GameFontHighlightSmall);
	textVersion:SetText(version);
	textVersion:SetSize(string.len(version), 10);
	
	textAuthor:SetPoint("TOPLEFT", 20 ,-55);
	textAuthor:SetFontObject(GameFontHighlightSmall);
	textAuthor:SetText(author);
	textAuthor:SetSize(string.len(author), 10);
	
	Page2_AdditionalSwitchTextFrom:SetPoint("TOPLEFT", Page2_AdditionalSwitchSliderMinimum_Text, 0, 30);
	Page2_AdditionalSwitchTextFrom:SetFontObject(GameFontHighlightMedium);
	Page2_AdditionalSwitchTextFrom:SetText("|cFF00FF00" .. L["Page2_AdditionalSwitchTextFrom"]);
	Page2_AdditionalSwitchTextFrom:SetSize(string.len(L["Page2_AdditionalSwitchTextFrom"]), 20);
	
	Page2_AdditionalSwitchTextTo:SetPoint("TOPLEFT", Page2_AdditionalSwitchSliderMaximum_Text, 140-(string.len(L["Page2_AdditionalSwitchTextTo"])), -30);
	Page2_AdditionalSwitchTextTo:SetFontObject(GameFontHighlightMedium);
	Page2_AdditionalSwitchTextTo:SetText("|cFF00FF00" .. L["Page2_AdditionalSwitchTextTo"]);
	Page2_AdditionalSwitchTextTo:SetSize(string.len(L["Page2_AdditionalSwitchTextTo"]), 20);
	
	Page2_AdditionalSwitchAvailableText:SetPoint("TOPLEFT", Page2_AdditionalSwitchddmProfiles, 20, 20);
	Page2_AdditionalSwitchAvailableText:SetFontObject(GameFontHighlightMedium);
	Page2_AdditionalSwitchAvailableText:SetText(L["Page2_AdditionalSwitchAvailableText"]);
	Page2_AdditionalSwitchAvailableText:SetSize(string.len(L["Page2_AdditionalSwitchAvailableText"]), 20);
	
	Page2_AdditionalSwitchSavedText:SetPoint("TOPLEFT", Page2_AdditionalSwitchddmSavedProfiles, 20, 20);
	Page2_AdditionalSwitchSavedText:SetFontObject(GameFontHighlightMedium);
	Page2_AdditionalSwitchSavedText:SetText(L["Page2_AdditionalSwitchSavedText"]);
	Page2_AdditionalSwitchSavedText:SetSize(string.len(L["Page2_AdditionalSwitchSavedText"]), 20);
	
	framePage3_Options_NormalText:SetPoint("TOPLEFT", fontFramePage3_Options, 50,-60);
	framePage3_Options_NormalText:SetFontObject(GameFontHighlightMedium);
	framePage3_Options_NormalText:SetText(L["Page3_Options_NormalText"]);
	framePage3_Options_NormalText:SetSize(string.len(L["Page3_Options_NormalText"]), 20);
	
	framePage3_Options_CriticalText:SetPoint("TOPLEFT", fontFramePage3_Options, 350,-60);
	framePage3_Options_CriticalText:SetFontObject(GameFontHighlightMedium);
	framePage3_Options_CriticalText:SetText(L["Page3_Options_CriticalText"]);
	framePage3_Options_CriticalText:SetSize(string.len(L["Page3_Options_CriticalText"]), 20);
end

local function createCheckbox()	
	SortGroup_Method_Debug("createCheckbox", "", 2);
	cBTop:SetPoint("TOPLEFT", fontFrame, 10, -100);
	cBBottom:SetPoint("TOPLEFT", fontFrame, 10, -200);
	cbTopDownwards:SetPoint("TOPLEFT", 30, -30);
	cbTopUpwards:SetPoint("TOPLEFT", 30, -55);
	cbBottomDownwards:SetPoint("TOPLEFT", 30, -30);
	cbBottomUpwards:SetPoint("TOPLEFT", 30, -55);
	cbRegardlessRaidProfile:SetPoint("TOPLEFT", fontFrame, 340, -100);
	cbAutoActivate:SetPoint("TOPLEFT",30,-30);	
	getglobal(cBTop:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cBTop_Option_Text"], "white"));
	getglobal(cBBottom:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cBBottom_Option_Text"], "white"));
	getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbDownwards_Option_Text"], "white"));
	getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbUpwards_Option_Text"], "white"));
	getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbDownwards_Option_Text"], "white"));
	getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbUpwards_Option_Text"], "white"));
	getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbAutoActivate_Option_Text"], "white"));
	getglobal(cbRegardlessRaidProfile:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbRegardlessRaidProfile_Option_Text"], "white"));
	--Page1
	
	Page2_AdditionalSwitchcbActive:SetPoint("TOPLEFT", fontFramePage2_AdditionalSwitch, 10, -60);
	getglobal(Page2_AdditionalSwitchcbActive:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page2_AdditionalSwitchcbActive_Option_Text"], "white"));
	--Page2
	
	Page3_cbChatMessagesOn:SetPoint("TOPLEFT", framePage3_Options_NormalText, 10, -40);
	Page3_cbChatMessagesCurrentOptions:SetPoint("TOPLEFT", 30, -30);
	Page3_cbChatMessagesRaidProfileSwitch:SetPoint("TOPLEFT", 30, -55);
	Page3_cbChatMessagesWarnings:SetPoint("TOPLEFT", 30, -80);
	Page3_cbRaidProfilesUpdateInCombat:SetPoint("TOPLEFT", framePage3_Options_NormalText, 10, -160);
	Page3_cbRaidProfilesUpdateInCombatVisibility:SetPoint("TOPLEFT", 30, -30);
	Page3_cbRaidProfilesSwitchInCombat:SetPoint("TOPLEFT", framePage3_Options_NormalText, 10, -230);
	Page3_cbChangesInCombat:SetPoint("TOPLEFT", framePage3_Options_CriticalText, 10, -40);
	Page3_cbDebugMode:SetPoint("TOPLEFT", framePage3_Options_CriticalText, 10,-70);
	Page3_cbDebugModeLevel1:SetPoint("TOPLEFT", 30, -30);
	Page3_cbDebugModeLevel2:SetPoint("TOPLEFT", 30, -55);
	Page3_cbDebugModeLevel3:SetPoint("TOPLEFT", 30, -80);
	getglobal(Page3_cbChatMessagesOn:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesOn_Option_Text"], "white"));
	getglobal(Page3_cbChatMessagesCurrentOptions:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesCurrentOptions_Option_Text"], "white"));
	getglobal(Page3_cbChatMessagesRaidProfileSwitch:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesRaidProfileSwitch_Option_Text"], "white"));
	getglobal(Page3_cbChatMessagesWarnings:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_ChatMessagesWarnings_Option_Text"], "white"));
	getglobal(Page3_cbRaidProfilesUpdateInCombat:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_RaidProfilesUpdateInCombat_Option_Text"], "white"));
	getglobal(Page3_cbRaidProfilesUpdateInCombatVisibility:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_RaidProfilesUpdateInCombatVisibility_Option_Text"], "white"));
	getglobal(Page3_cbRaidProfilesSwitchInCombat:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_RaidProfilesSwitchInCombat_Option_Text"], "white"));
	getglobal(Page3_cbChangesInCombat:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_ChangesInCombat_Option_Text"], "white"));
	getglobal(Page3_cbDebugMode:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugMode_Option_Text"], "white"));
	getglobal(Page3_cbDebugModeLevel1:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel1_Option_Text"], "white"));
	getglobal(Page3_cbDebugModeLevel2:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel2_Option_Text"], "white"));
	getglobal(Page3_cbDebugModeLevel3:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel3_Option_Text"], "white"));
	--Page3
end

local function createButton()
	SortGroup_Method_Debug("createButton", "", 2);
	Page2_AdditionalSwitchbtnSave:SetSize(120, 24);
	Page2_AdditionalSwitchbtnSave:SetText(L["Page2_AdditionalSwitchbtnSave_text"]);
	Page2_AdditionalSwitchbtnSave:SetPoint("TOPLEFT", fontFramePage2_AdditionalSwitch, 300, -260)
	
	Page2_AdditionalSwitchbtnDelete:SetSize(120, 24);
	Page2_AdditionalSwitchbtnDelete:SetText(L["Page2_AdditionalSwitchbtnDelete_text"]);
	Page2_AdditionalSwitchbtnDelete:SetPoint("TOPLEFT", fontFramePage2_AdditionalSwitch, 450, -260)
	
	Page2_AdditionalSwitchbtnReset:SetSize(120, 24);
	Page2_AdditionalSwitchbtnReset:SetText(L["Page2_AdditionalSwitchbtnReset_text"]);
	Page2_AdditionalSwitchbtnReset:SetPoint("TOPLEFT", fontFramePage2_AdditionalSwitch, 450, -300)
	
	Page3_OptionsbtnReload:SetSize(120, 24);
	Page3_OptionsbtnReload:SetText(L["Page3_OptionsbtnReload_text"]);
	Page3_OptionsbtnReload:SetPoint("TOPLEFT", fontFramePage3_Options, 40, -450)
end

local function createDropDownMenu()
	SortGroup_Method_Debug("createDropDownMenu", "", 2);
	ddmProfiles.text = _G["DropDownMenuProfiles"];
	ddmProfiles.text:SetText("Empty ddm");
	ddmProfiles:SetPoint("TOPLEFT", -10, -30);		
	ddmProfiles.info = {};
	ddmProfiles.initialize = function(self, level)
		if ( SortGroup_Variable_inCombat == false and level == 1 ) then
			wipe(self.info);
			SortGroup_Method_ReadAllRaidProfiles();
			for i, value in pairs(SortGroup_Variable_ddmItems) do
				self.info.text = value;
				self.info.value = i;
				self.info.func = function(item)
					if ( SortGroup_Method_RaidProfilOnLoadExists(value) == true ) then
						table.remove(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad, SortGroup_Variable_raidProfilOnLoadIndex);
					end
					self.selectedID = item:GetID();
					self.text:SetText(item);
					self.value = i;
					SortGroup_Variable_raidProfile = value;
					UIDropDownMenu_SetText(ddmProfiles, SortGroup_Variable_raidProfile);
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					SortGroup_Method_DisableSliders();
					SortGroup_Method_fillArray();
					SortGroup_Variable_showChatMessage = true;
					SortGroup_Method_SendSortOptionToSortBy(true);
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
				if ( SortGroup_Variable_raidProfile == self.info.text ) then
					UIDropDownMenu_SetSelectedID(ddmProfiles, i);
				end
			end
		else
			if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
				print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	ddmProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["ddmProfiles_Title"] .. "\n\n" .. SortGroup_Method_ColorPrint(L["ddmProfiles_ToolTip_Text"], "white"), nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	ddmProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	
	
	Page2_AdditionalSwitchddmProfiles.text = _G["DropDownMenuProfiles"];
	Page2_AdditionalSwitchddmProfiles.text:SetText("Empty ddm");
	Page2_AdditionalSwitchddmProfiles:SetPoint("TOPLEFT",fontFramePage2_AdditionalSwitch, 25, -140);		
	Page2_AdditionalSwitchddmProfiles.info = {};
	Page2_AdditionalSwitchddmProfiles.initialize = function(self, level)
		if ( SortGroup_Variable_inCombat == false and level == 1 ) then
			wipe(self.info);
			SortGroup_Method_DeleteRaidProfileNotExists();
			SortGroup_Method_ReadAllRaidProfiles();
			for i, value in pairs(SortGroup_Variable_ddmItems) do
				if ( SortGroup_Method_RaidProfilOnLoadExists(value) == false ) then
					self.info.text = value;
					self.info.value = i;
					self.info.func = function(item)
						self.selectedID = item:GetID();
						self.text:SetText(item);
						self.value = i;
						SortGroup_Variable_Page2_AdditionalSwitchraidProfile = value;
						UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
						UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, SortGroup_Variable_Page2_AdditionalSwitchraidProfile);					
						SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved = nil;
						if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfile == SortGroup_Variable_raidProfile and SortGroup_Variable_GroupAutoActivate == true ) then
							Page2_AdditionalSwitchSliderMinimum:Disable();
							Page2_AdditionalSwitchSliderMaximum:Disable();
							Page2_AdditionalSwitchbtnSave:Disable();
							Page2_AdditionalSwitchbtnDelete:Disable();
							Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(1, 5);
							Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(1, 5);
							Page2_AdditionalSwitchSliderMinimum_Text:SetValue(1);
							Page2_AdditionalSwitchSliderMaximum_Text:SetValue(5);									
							getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText(SortGroup_Method_ColorPrint('1', "disable"));
							getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText(SortGroup_Method_ColorPrint('5', "disable"));
							getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()), "disable"));
							getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText(SortGroup_Method_ColorPrint('1', "disable"));
							getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText(SortGroup_Method_ColorPrint('5', "disable"))
							getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()), "disable"));
						else
							Page2_AdditionalSwitchSliderMinimum:Enable();
							Page2_AdditionalSwitchSliderMaximum:Enable();
							Page2_AdditionalSwitchbtnSave:Enable();
							if ( SortGroup_Variable_GroupAutoActivate == true ) then
								Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(6, 40);
								Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(6, 40);
								Page2_AdditionalSwitchSliderMinimum_Text:SetValue(6);
								Page2_AdditionalSwitchSliderMaximum_Text:SetValue(40);
								getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('6');
								getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
								getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('6');
								getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40')
							else
								Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(1, 40);
								Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(1, 40);
								Page2_AdditionalSwitchSliderMinimum_Text:SetValue(1);
								Page2_AdditionalSwitchSliderMaximum_Text:SetValue(40);
								getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('1');
								getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
								getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('1');
								getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40')						
							end
							SortGroup_Method_UpdateSliders("ddmProfiles");
						end
					end
					self.info.checked = i == self.text:GetText();
					UIDropDownMenu_AddButton(self.info, level);
					if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfile == self.info.text ) then
						UIDropDownMenu_SetSelectedID(Page2_AdditionalSwitchddmProfiles, i)
					end
				end
			end
		else
			if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
				print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	Page2_AdditionalSwitchddmProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page2_AdditionalSwitchAvailableText"] .. "\n\n" .. SortGroup_Method_ColorPrint(L["Page2_AdditionalSwitchddmProfiles_ToolTip_Text"], "white"), nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page2_AdditionalSwitchddmProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	
	Page2_AdditionalSwitchddmSavedProfiles.text = _G["DropDownMenuProfiles"];
	Page2_AdditionalSwitchddmSavedProfiles.text:SetText("Empty ddm");
	Page2_AdditionalSwitchddmSavedProfiles:SetPoint("TOPLEFT",fontFramePage2_AdditionalSwitch, 425, -140);		
	Page2_AdditionalSwitchddmSavedProfiles.info = {};
	Page2_AdditionalSwitchddmSavedProfiles.initialize = function(self, level)
		if ( SortGroup_Variable_inCombat == false and level == 1 ) then
			wipe(self.info);
			SortGroup_Method_DeleteRaidProfileNotExists()
			SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter = 0;
			for i = 1, (SortGroup_Method_CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad)), 1 do
				self.info.text = SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName;
				self.info.value = i;
				SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter = SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter + 1;
				self.info.func = function(item)
					self.selectedID = item:GetID();
					self.text:SetText(item);
					self.value = i;
					SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved = SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName;
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					Page2_AdditionalSwitchbtnDelete:Enable();
					Page2_AdditionalSwitchbtnSave:Enable();
					Page2_AdditionalSwitchSliderMinimum:Enable();
					Page2_AdditionalSwitchSliderMaximum:Enable();
					SortGroup_Variable_Page2_AdditionalSwitchraidProfile = nil;
					if ( SortGroup_Variable_GroupAutoActivate == true ) then
						Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(6, 40);
						Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(6, 40);
						Page2_AdditionalSwitchSliderMinimum_Text:SetValue(6);
						Page2_AdditionalSwitchSliderMaximum_Text:SetValue(40);
						getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('6');
						getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
						getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('6');
						getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40')
					else
						Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(1, 40);
						Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(1, 40);
						getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('1');
						getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
						getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('1');
						getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40')			
					end
					SortGroup_Method_UpdateSliders("ddmSelectedProfiles",i);
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
				if ( Page2_AdditionalSwitchddmSavedProfiles == self.info.text ) then
					UIDropDownMenu_SetSelectedID(Page2_AdditionalSwitchddmSavedProfiles, i)
				end
			end
		else
			if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
				print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	Page2_AdditionalSwitchddmSavedProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page2_AdditionalSwitchSavedText"] .. "\n\n" .. SortGroup_Method_ColorPrint(L["Page2_AdditionalSwitchddmSelectedProfiles_ToolTip_Text"], "white"), nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page2_AdditionalSwitchddmSavedProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
end
--DropDownMenu creating, include items

local function createSliders()
	SortGroup_Method_Debug("createSliders", "", 2);
	Page2_AdditionalSwitchSliderMinimum_Text:SetSize(150, 17);
	Page2_AdditionalSwitchSliderMinimum_Text:SetPoint("TOPLEFT", fontFramePage2_AdditionalSwitch, 230, -120);
	Page2_AdditionalSwitchSliderMinimum_Text:SetOrientation('HORIZONTAL');
	Page2_AdditionalSwitchSliderMinimum_Text:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal");
	Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(1,40);
	Page2_AdditionalSwitchSliderMinimum_Text:SetValue(1);
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('1');
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText(Page2_AdditionalSwitchSliderMinimum:GetValue());
	Page2_AdditionalSwitchSliderMinimum_Text:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	Page2_AdditionalSwitchSliderMinimum_Text:SetValueStep(1);
	
	Page2_AdditionalSwitchSliderMaximum_Text:SetSize(150, 17);
	Page2_AdditionalSwitchSliderMaximum_Text:SetPoint("TOPLEFT", fontFramePage2_AdditionalSwitch, 230, -170);
	Page2_AdditionalSwitchSliderMaximum_Text:SetOrientation('HORIZONTAL');
	Page2_AdditionalSwitchSliderMaximum_Text:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal");
	Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(1,40);
	Page2_AdditionalSwitchSliderMaximum_Text:SetValue(40);
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('1');
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40');
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText(Page2_AdditionalSwitchSliderMaximum:GetValue());
	Page2_AdditionalSwitchSliderMaximum_Text:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	Page2_AdditionalSwitchSliderMaximum_Text:SetValueStep(1);
end
--- End Creating



local function frameEvent()
	SortGroup_Method_Debug("frameEvent", "", 2);
	SortGroup_Variable_frame:RegisterEvent("COMPACT_UNIT_FRAME_PROFILES_LOADED");
	SortGroup_Variable_frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	SortGroup_Variable_frame:RegisterEvent("PLAYER_LOGOUT");
	SortGroup_Variable_frame:RegisterEvent("PLAYER_REGEN_DISABLED");
	SortGroup_Variable_frame:RegisterEvent("PLAYER_REGEN_ENABLED");
	SortGroup_Variable_frame:RegisterEvent("GROUP_ROSTER_UPDATE");
	SortGroup_Variable_frame:SetScript("OnEvent", 
		function(self, event, ...)	
			if ( event == "PLAYER_LOGOUT" ) then 
				SortGroup_Method_Debug("PLAYER_LOGOUT", "", 2);
				SortGroup_Method_SaveOptions();
				SortGroup_Variable_frame:UnregisterEvent(event);
			elseif ( event == "PLAYER_REGEN_DISABLED" ) then
				SortGroup_Method_Debug("PLAYER_REGEN_DISABLED", "", 2);
				SortGroup_Variable_inCombat = true;
			elseif ( event == "PLAYER_REGEN_ENABLED" ) then
				SortGroup_Method_Debug("PLAYER_REGEN_ENABLED", "", 2);
				SortGroup_Variable_inCombat = false;
				for k, v in pairs(SortGroup_Variable_CompactSave) do
					SortGroup_Variable_CompactSave[k] = nil
					_G[v](_G[k])
				end
				if ( SortGroup_Variable_GroupAutoActivate == true or SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
					SortGroup_Method_SendSortOptionToSortBy(true);
				else
					SortGroup_Method_SendSortOptionToSortBy(false);
				end
			elseif ( event == "GROUP_ROSTER_UPDATE" ) then
				SortGroup_Method_Debug("GROUP_ROSTER_UPDATE", "", 2);
				if ( SortGroup_Variable_GroupAutoActivate == true or SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
					SortGroup_Method_SendSortOptionToSortBy(true);
				else
					SortGroup_Method_SendSortOptionToSortBy(false);
				end
			elseif ( event == "COMPACT_UNIT_FRAME_PROFILES_LOADED" ) then
				SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "", 2)
				if ( SortGroupInformation.Down == nil or SortGroupInformation.Up == nil ) then
					SortGroupInformation.Down = SortGroup_Variable_GroupTop;
					SortGroupInformation.Up = SortGroup_Variable_GroupBottom;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Down/Up = nil - new");
				end	
				if ( SortGroupInformation.TopDownwards == nil or SortGroupInformation.TopUpwards == nil or SortGroupInformation.BottomDownwards == nil or SortGroupInformation.BottomUpwards == nil ) then
					SortGroupInformation.TopDownwards = SortGroup_Variable_GroupTopDownwards;
					SortGroupInformation.TopUpwards	= SortGroup_Variable_GroupTopUpwards;
					SortGroupInformation.BottomDownwards = SortGroup_Variable_GroupBottomDownwards;
					SortGroupInformation.BottomUpwards = SortGroup_Variable_GroupBottomUpwards;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Down = true, Down/Up - new");
				end
				if ( SortGroupInformation.Profile == nil ) then
					SortGroupInformation.Profile = GetRaidProfileName(1);
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.Profile = nil - new");
				end				
				if ( SortGroupInformation.AutoActivate == nil ) then
					SortGroupInformation.AutoActivate = SortGroup_Variable_GroupAutoActivate;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.AutoActivate = nil - new");
				end				
				if ( SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile == nil ) then
					SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile = false;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile = nil - new");
				end
				if ( SortGroupInformation.chatMessagesOn ~= nil ) then
					SortGroupInformation.Page3_ChatMessagesOn = SortGroupInformation.chatMessagesOn;
					SortGroupInformation.chatMessagesOn = nil;
					-- Delete old variable - chatMessagesOn
				end
				if ( SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive == nil ) then
					SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive = SortGroup_Variable_Page2_AdditionalSwitchActive;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive = nil - new");
				end
				if ( SortGroupInformation.RaidProfileOnLoad == nil ) then
					SortGroupInformation.RaidProfileOnLoad = {};	
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.RaidProfileOnLoad = nil - new");					
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn = SortGroup_Variable_Page3_chatMessagesOn;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn = nil - new");
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_chatMessagesCurrentOptions == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_chatMessagesCurrentOptions = SortGroup_Variable_Page3_chatMessagesCurrentOptions;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_chatMessagesCurrentOptions = nil - new");
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch = SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch = nil - new");
				end			
				if ( SortGroupInformation.SortGroup_Variable_Page3_ChatMessagesWarnings == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_ChatMessagesWarnings = SortGroup_Variable_Page3_ChatMessagesWarnings;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_ChatMessagesWarnings = nil - new");
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = SortGroup_Variable_Page3_RaidProfilesUpdateInCombat;	
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = nil - new");					
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility = SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility;	
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility = nil - new");
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesSwitchInCombat == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesSwitchInCombat = SortGroup_Variable_Page3_RaidProfilesSwitchInCombat;
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesSwitchInCombat = nil - new");	
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat = SortGroup_Variable_Page3_ChangesInCombat;	
					SortGroup_Method_Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat = nil - new");					
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_Options_DebugMode == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_Options_DebugMode = SortGroup_Variable_Page3_Options_DebugMode;
					SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel1 = SortGroup_Variable_Page3_Options_DebugModeLevel1;
					SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel2 = SortGroup_Variable_Page3_Options_DebugModeLevel2;
					SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel3 = SortGroup_Variable_Page3_Options_DebugModeLevel3;
				end
				
				SortGroup_Variable_GroupTop = SortGroupInformation.Down;
				SortGroup_Variable_GroupBottom = SortGroupInformation.Up;
				SortGroup_Variable_GroupTopDownwards = SortGroupInformation.TopDownwards;
				SortGroup_Variable_GroupTopUpwards = SortGroupInformation.TopUpwards;
				SortGroup_Variable_GroupBottomDownwards = SortGroupInformation.BottomDownwards;
				SortGroup_Variable_GroupBottomUpwards = SortGroupInformation.BottomUpwards;
				SortGroup_Variable_GroupAutoActivate = SortGroupInformation.AutoActivate;
				SortGroup_Variable_RegardlessRaidProfile = SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile;
				SortGroup_Variable_raidProfile = SortGroupInformation.Profile;
				
				SortGroup_Variable_Page2_AdditionalSwitchActive = SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive;
				SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = SortGroupInformation.RaidProfileOnLoad;
				SortGroup_Method_DeleteRaidProfileNotExists();
				--SortGroup_Method_fillArray();
				
				SortGroup_Variable_Page3_chatMessagesOn = SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn;
				SortGroup_Variable_Page3_chatMessagesCurrentOptions = SortGroupInformation.SortGroup_Variable_Page3_chatMessagesCurrentOptions;
				SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch = SortGroupInformation.SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch;
				SortGroup_Variable_Page3_ChatMessagesWarnings = SortGroupInformation.SortGroup_Variable_Page3_ChatMessagesWarnings;
				SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat;	
				SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility = SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility;
				SortGroup_Variable_Page3_RaidProfilesSwitchInCombat = SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesSwitchInCombat;
				SortGroup_Variable_Page3_ChangesInCombat = SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat;
				SortGroup_Variable_Page3_Options_DebugMode = SortGroupInformation.SortGroup_Variable_Page3_Options_DebugMode;
				SortGroup_Variable_Page3_Options_DebugModeLevel1 = SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel1;
				SortGroup_Variable_Page3_Options_DebugModeLevel2 = SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel2;
				SortGroup_Variable_Page3_Options_DebugModeLevel3 = SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel3;
				
				UIDropDownMenu_SetText(ddmProfiles, SortGroup_Variable_raidProfile)
				SortGroup_Method_UpdateComboBoxes();
				--Get informations
				
				if ( SortGroup_Variable_Page3_RaidProfilesUpdateInCombat == false ) then
					SortGroup_Method_resetRaidContainer();
				end
				-- Necessary to put her. Otherwise method doesn't get current variables
				
				SortGroup_Variable_showChatMessage = true;
				SortGroup_Method_SendSortOptionToSortBy(true);
				SortGroup_Variable_frame:UnregisterEvent(event);	
			elseif ( event == "PLAYER_ENTERING_WORLD" and HasLoadedCUFProfiles() == true and SortGroup_Variable_inCombat == false) then	
				SortGroup_Method_Debug("PLAYER_ENTERING_WORLD", "", 2);		
				SortGroup_Method_SendSortOptionToSortBy(false);
				-- Start sort
			end
		end);
end

local function checkBoxEvent()
	SortGroup_Method_Debug("checkBoxEvent", "", 2);
	cBTop:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("cBTop", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cBTop:GetChecked() == true ) then
					SortGroup_Variable_GroupTop = true;
					SortGroup_Variable_GroupBottom = false;
					if ( cbTopDownwards:GetChecked() == false and cbTopUpwards:GetChecked() == false ) then
						SortGroup_Variable_GroupTopDownwards = true;
					end
				elseif ( cBTop:GetChecked() == false ) then	
					SortGroup_Variable_GroupTop = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_UpdateComboBoxes();
				SortGroup_Method_SendSortOptionToSortBy(false);
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cBTop:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBTop_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["cBTop_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBTop:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Top
		
	cBBottom:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("cBBottom", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cBBottom:GetChecked() == true ) then
					SortGroup_Variable_GroupTop = false;
					SortGroup_Variable_GroupBottom = true;
					if ( cbBottomDownwards:GetChecked() == false and cbBottomUpwards:GetChecked() == false ) then
						SortGroup_Variable_GroupBottomUpwards = true;
						cbBottomUpwards:SetChecked(true);
					end
				elseif ( cBBottom:GetChecked() == false ) then	
					SortGroup_Variable_GroupBottom = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_UpdateComboBoxes();
				SortGroup_Method_SendSortOptionToSortBy(false);
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	cBBottom:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBBottom_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["cBBottom_ToolTip_text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBBottom:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Bottom
	
	cbTopDownwards:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("cbTopDownwards", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbTopDownwards:GetChecked() == true ) then
					SortGroup_Variable_GroupTopDownwards = true;
					SortGroup_Variable_GroupTopUpwards = false;
				elseif ( cbTopDownwards:GetChecked() == false ) then	
					SortGroup_Variable_GroupTopDownwards = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_UpdateComboBoxes();
				SortGroup_Method_SendSortOptionToSortBy(false);
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbTopDownwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbDownwards_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["cbDownwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbTopDownwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbTopUpwards:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("cbTopUpwards", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbTopUpwards:GetChecked() == true ) then
					SortGroup_Variable_GroupTopDownwards = false;
					SortGroup_Variable_GroupTopUpwards = true;
				elseif ( cbTopUpwards:GetChecked() == false ) then	
					SortGroup_Variable_GroupTopUpwards = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_UpdateComboBoxes();
				SortGroup_Method_SendSortOptionToSortBy(false);
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbTopUpwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbUpwards_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["cbUpwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbTopUpwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbBottomDownwards:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("cbBottomDownwards", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbBottomDownwards:GetChecked() == true ) then
					SortGroup_Variable_GroupBottomDownwards = true;
					SortGroup_Variable_GroupBottomUpwards = false;
				elseif ( cbBottomDownwards:GetChecked() == false ) then	
					SortGroup_Variable_GroupBottomDownwards = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_SendSortOptionToSortBy(false);
				SortGroup_Method_UpdateComboBoxes();
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbBottomDownwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbDownwards_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["cbDownwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbBottomDownwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbBottomUpwards:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("cbBottomUpwards", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbBottomUpwards:GetChecked() == true ) then
					SortGroup_Variable_GroupBottomDownwards = false;
					SortGroup_Variable_GroupBottomUpwards = true;
				elseif ( cbBottomUpwards:GetChecked() == false ) then	
					SortGroup_Variable_GroupBottomUpwards = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_SendSortOptionToSortBy(false);
				SortGroup_Method_UpdateComboBoxes();
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbBottomUpwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbUpwards_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["cbUpwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbBottomUpwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
		
	cbAutoActivate:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("cbAutoActivate", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbAutoActivate:GetChecked() == true ) then
					SortGroup_Variable_GroupAutoActivate = true;
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					if ( SortGroup_Method_RaidProfilOnLoadExists(SortGroup_Variable_raidProfile) == true ) then
						table.remove(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad, SortGroup_Variable_raidProfilOnLoadIndex);
					end
					if ( SortGroup_Variable_GroupAutoActivate == true or SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
						SortGroup_Method_SendSortOptionToSortBy(true);
					else
						SortGroup_Method_SendSortOptionToSortBy(false);
					end
				elseif ( cbAutoActivate:GetChecked() == false ) then
					SortGroup_Variable_GroupAutoActivate = false;
				end
				UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
				UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
				SortGroup_Method_DisableSliders();
				SortGroup_Method_fillArray();
				SortGroup_Method_SaveOptions();
				SortGroup_Method_SendSortOptionToSortBy(false);
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbAutoActivate:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbAutoActivate_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["cbAutoActivate_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAutoActivate:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox AutoActive
		
	cbRegardlessRaidProfile:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("cbRegardlessRaidProfile", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbRegardlessRaidProfile:GetChecked() == true ) then
					SortGroup_Variable_RegardlessRaidProfile = true;
					--SortGroup_Variable_cacheAutoActive = AutoActivate;
					--AutoActivate = false;
					UIDropDownMenu_DisableDropDown(ddmProfiles);
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					if ( SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
						SortGroup_Method_SendSortOptionToSortBy(true);
					else
						SortGroup_Method_SendSortOptionToSortBy(false);
					end
				elseif ( cbRegardlessRaidProfile:GetChecked() == false ) then
					SortGroup_Variable_RegardlessRaidProfile = false;
					--AutoActivate = SortGroup_Variable_cacheAutoActive;
					cbAutoActivate:Enable();
					UIDropDownMenu_EnableDropDown(ddmProfiles);
					getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
				end
				UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
				UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
				SortGroup_Method_DisableSliders();
				SortGroup_Method_fillArray();
				SortGroup_Method_SaveOptions();
				SortGroup_Method_UpdateComboBoxes();
				SortGroup_Method_SendSortOptionToSortBy(false);
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbRegardlessRaidProfile:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbRegardlessRaidProfile_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["cbRegardlessRaidProfile_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbRegardlessRaidProfile:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_RegardlessRaidProfile
			
	
	Page2_AdditionalSwitchcbActive:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page2_AdditionalSwitchcbActive", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page2_AdditionalSwitchcbActive:GetChecked() == true ) then
					SortGroup_Variable_Page2_AdditionalSwitchActive = true;
					UIDropDownMenu_EnableDropDown(Page2_AdditionalSwitchddmProfiles);
					UIDropDownMenu_EnableDropDown(Page2_AdditionalSwitchddmSavedProfiles);
					Page2_AdditionalSwitchbtnReset:Enable();
				elseif ( Page2_AdditionalSwitchcbActive:GetChecked() == false ) then
					SortGroup_Variable_Page2_AdditionalSwitchActive = false;
					UIDropDownMenu_DisableDropDown(Page2_AdditionalSwitchddmProfiles);
					UIDropDownMenu_DisableDropDown(Page2_AdditionalSwitchddmSavedProfiles);
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
					Page2_AdditionalSwitchbtnDelete:Disable();
					Page2_AdditionalSwitchbtnReset:Disable();
					SortGroup_Method_DisableSliders();
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	Page2_AdditionalSwitchcbActive:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page2_AdditionalSwitchcbActive_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page2_AdditionalSwitchcbActive_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page2_AdditionalSwitchcbActive:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page2_AdditionalSwitchActive
	
	Page3_cbChatMessagesOn:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page3_cbChatMessagesOn", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page3_cbChatMessagesOn:GetChecked() == true ) then
					SortGroup_Variable_Page3_chatMessagesOn = true;
					print(SortGroup_Method_ColorPrint(L["chat_Messages_On"], "option"));
				elseif ( Page3_cbChatMessagesOn:GetChecked() == false ) then
					SortGroup_Variable_Page3_chatMessagesOn = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbChatMessagesOn:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbChatMessagesOn_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesOn_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbChatMessagesOn:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page3_chatMessagesOn

	Page3_cbChatMessagesCurrentOptions:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page3_cbChatMessagesCurrentOptions", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page3_cbChatMessagesCurrentOptions:GetChecked() == true ) then
					SortGroup_Variable_Page3_chatMessagesCurrentOptions = true;
				elseif ( Page3_cbChatMessagesCurrentOptions:GetChecked() == false ) then
					SortGroup_Variable_Page3_chatMessagesCurrentOptions = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesCurrentOptions == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbChatMessagesCurrentOptions:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbChatMessagesCurrentOptions_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesCurrentOptions_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbChatMessagesCurrentOptions:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox Page3_cbChatMessagesCurrentOptions
	
	Page3_cbChatMessagesRaidProfileSwitch:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page3_cbChatMessagesRaidProfileSwitch", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page3_cbChatMessagesRaidProfileSwitch:GetChecked() == true ) then
					SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch = true;
				elseif ( Page3_cbChatMessagesRaidProfileSwitch:GetChecked() == false ) then
					SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbChatMessagesRaidProfileSwitch:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbChatMessagesRaidProfileSwitch_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesRaidProfileSwitch_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbChatMessagesRaidProfileSwitch:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox Page3_cbChatMessagesRaidProfileSwitch
	
	Page3_cbChatMessagesWarnings:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page3_cbChatMessagesWarnings", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page3_cbChatMessagesWarnings:GetChecked() == true ) then
					SortGroup_Variable_Page3_ChatMessagesWarnings = true;
				elseif ( Page3_cbChatMessagesWarnings:GetChecked() == false ) then
					SortGroup_Variable_Page3_ChatMessagesWarnings = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("checkBoxEvent", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_ChatMessagesWarnings == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbChatMessagesWarnings:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_ChatMessagesWarnings_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_ChatMessagesWarnings_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbChatMessagesWarnings:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox Page3_cbChatMessagesWarnings
	
	Page3_cbRaidProfilesUpdateInCombat:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page3_cbRaidProfilesUpdateInCombat", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page3_cbRaidProfilesUpdateInCombat:GetChecked() == true ) then
					SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = true;
				elseif ( Page3_cbRaidProfilesUpdateInCombat:GetChecked() == false ) then
					SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("Page3_cbRaidProfilesUpdateInCombat", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbRaidProfilesUpdateInCombat:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_RaidProfilesUpdateInCombat_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_RaidProfilesUpdateInCombat_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbRaidProfilesUpdateInCombat:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page3_RaidProfilesUpdateInCombat
	
	Page3_cbRaidProfilesUpdateInCombatVisibility:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page3_cbRaidProfilesUpdateInCombatVisibility", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page3_cbRaidProfilesUpdateInCombatVisibility:GetChecked() == true ) then
					SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility = true;
				elseif ( Page3_cbRaidProfilesUpdateInCombatVisibility:GetChecked() == false ) then
					SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("Page3_cbRaidProfilesUpdateInCombatVisibility", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbRaidProfilesUpdateInCombatVisibility:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_RaidProfilesUpdateInCombatVisibility_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_RaidProfilesUpdateInCombatVisibility_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbRaidProfilesUpdateInCombatVisibility:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox Page3_cbRaidProfilesUpdateInCombatVisibility
	
	Page3_cbRaidProfilesSwitchInCombat:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page3_cbRaidProfilesSwitchInCombat", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page3_cbRaidProfilesSwitchInCombat:GetChecked() == true ) then
					SortGroup_Variable_Page3_RaidProfilesSwitchInCombat = true;
				elseif ( Page3_cbRaidProfilesSwitchInCombat:GetChecked() == false ) then
					SortGroup_Variable_Page3_RaidProfilesSwitchInCombat = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("Page3_cbRaidProfilesSwitchInCombat", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbRaidProfilesSwitchInCombat:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_RaidProfilesSwitchInCombat_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_RaidProfilesSwitchInCombat_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbRaidProfilesSwitchInCombat:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page3_RaidProfilesSwitchInCombat
	
	Page3_cbChangesInCombat:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page3_cbChangesInCombat", "", 2);
			if ( Page3_cbChangesInCombat:GetChecked() == true ) then
				SortGroup_Variable_Page3_ChangesInCombat = true;
			elseif ( Page3_cbChangesInCombat:GetChecked() == false ) then
				SortGroup_Variable_Page3_ChangesInCombat = false;
			end
			SortGroup_Method_SaveOptions();
			SortGroup_Method_Debug("Page3_cbChangesInCombat", "", 1);
		end);
	Page3_cbChangesInCombat:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_ChangesInCombat_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_ChangesInCombat_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbChangesInCombat:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page3_ChangesInCombat
	
	Page3_cbDebugMode:SetScript("OnClick",
		function()
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Method_Debug("Page3_cbDebugMode", "", 2);
				if ( Page3_cbDebugMode:GetChecked() == true ) then
					SortGroup_Variable_Page3_Options_DebugMode = true;
				elseif ( Page3_cbDebugMode:GetChecked() == false ) then
					SortGroup_Variable_Page3_Options_DebugMode = false;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("Page3_cbDebugMode", "", 1);
				SortGroup_Method_UpdateComboBoxes();
			else
				SortGroup_Method_UpdateComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbDebugMode:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbDebugMode_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_cbDebugMode_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbDebugMode:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	Page3_cbDebugModeLevel1:SetScript("OnClick",
		function()
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Method_Debug("Page3_cbDebugModeLevel1", "", 2);
				if ( Page3_cbDebugModeLevel1:GetChecked() == true ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel1 = true;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 1;
				elseif ( Page3_cbDebugModeLevel1:GetChecked() == false ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel1 = false;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel - 1;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("Page3_cbDebugModeLevel1", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbDebugModeLevel1:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbDebugModeLevel1_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel1_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbDebugModeLevel1:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	Page3_cbDebugModeLevel2:SetScript("OnClick",
		function()
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Method_Debug("Page3_cbDebugModeLevel2", "", 2);
				if ( Page3_cbDebugModeLevel2:GetChecked() == true ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel2 = true;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 2;
				elseif ( Page3_cbDebugModeLevel2:GetChecked() == false ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel2 = false;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel - 2;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("Page3_cbDebugModeLevel2", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbDebugModeLevel2:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbDebugModeLevel2_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel2_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbDebugModeLevel2:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	Page3_cbDebugModeLevel3:SetScript("OnClick",
		function()
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Method_Debug("Page3_cbDebugModeLevel3", "", 2);
				if ( Page3_cbDebugModeLevel3:GetChecked() == true ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel3 = true;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 4;
				elseif ( Page3_cbDebugModeLevel3:GetChecked() == false ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel3 = false;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel - 4;
				end
				SortGroup_Method_SaveOptions();
				SortGroup_Method_Debug("Page3_cbDebugModeLevel3", "", 1);
			else
				SortGroup_Method_UpdateComboBoxes();
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
					print(SortGroup_Method_ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbDebugModeLevel3:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbDebugModeLevel3_Option_Text"] .."\n\n" .. SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel3_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbDebugModeLevel3:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
end
--ComboBox Events

local function buttonEvent()
	SortGroup_Method_Debug("buttonEvent", "", 2);
	Page2_AdditionalSwitchbtnSave:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page2_AdditionalSwitchbtnSave", "", 2);
			if ( math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) <= math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ) then
				if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfile ~= nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfile ~= "" ) then
					if ( SortGroup_Method_RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfile) == false ) then
						if ( SortGroup_Method_ElementIsInArray( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) ) == nil ) then
							number = SortGroup_Method_CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad) + 1;
							SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[number] = {}
							SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[number].RaidProfileName = SortGroup_Variable_Page2_AdditionalSwitchraidProfile;
							SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[number].Minimum = math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue());
							SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[number].Maximum =  math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue());
							UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
							UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");	
							Page2_AdditionalSwitchbtnDelete:Disable();
							Page2_AdditionalSwitchbtnSave:Disable();
							SortGroup_Method_DisableSliders();
							SortGroup_Method_fillArray();
							if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
								local cache1PrintPage2_AdditionalSwitchbtnSave = L["Saved_RaidProfile_OnLoad"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfile):gsub("'replacement2'", math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()));
								print( SortGroup_Method_ColorPrint(cache1PrintPage2_AdditionalSwitchbtnSave:gsub("'replacement3'", math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "option") );
							end
						elseif ( SortGroup_Variable_Page3_chatMessagesOn == true and ( SortGroup_Variable_Page3_chatMessagesCurrentOptions == true or SortGroup_Variable_Page3_ChatMessagesWarnings == true ) ) then
							local cache2PrintPage2_AdditionalSwitchbtnSave =  SortGroup_Method_ElementIsInArray( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) );
							print( SortGroup_Method_ColorPrint(L["already_in_use"]:gsub("'replacement'", cache2PrintPage2_AdditionalSwitchbtnSave), "option") );
						end
					elseif ( SortGroup_Variable_Page3_chatMessagesOn == true and ( SortGroup_Variable_Page3_chatMessagesCurrentOptions == true or SortGroup_Variable_Page3_ChatMessagesWarnings == true ) ) then
						local cache3PrintPage2_AdditionalSwitchbtnSave =  SortGroup_Method_ElementIsInArray( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) );
						print( SortGroup_Method_ColorPrint(L["already_in_use"]:gsub("'replacement'", cache3PrintPage2_AdditionalSwitchbtnSave), "option") );
					end
				elseif ( SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= "" ) then
					SortGroup_Method_RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
					if ( SortGroup_Method_ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ) == true ) then					
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].RaidProfileName = SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved;
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Minimum = math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue());
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Maximum =  math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue());
						UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
						Page2_AdditionalSwitchbtnSave:Disable();
						SortGroup_Method_fillArray();
						if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
							local cache4PrintPage2_AdditionalSwitchbtnSave = L["Saved_RaidProfile_OnLoad"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved):gsub("'replacement2'", math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()));
							print( SortGroup_Method_ColorPrint(cache4PrintPage2_AdditionalSwitchbtnSave:gsub("'replacement3'", math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "option") );
						end
					elseif ( SortGroup_Variable_Page3_chatMessagesOn == true and ( SortGroup_Variable_Page3_chatMessagesCurrentOptions == true or SortGroup_Variable_Page3_ChatMessagesWarnings == true ) ) then
						print( SortGroup_Method_ColorPrint(L["already_in_use"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfilOnThatPlace), "option") );
					end
				end
				if ( SortGroup_Method_CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad) > 0 ) then
					Page2_AdditionalSwitchbtnReset:Enable();
				else
					Page2_AdditionalSwitchbtnReset:Disable();
				end
				SortGroup_Method_SaveOptions();
				if ( SortGroup_Variable_GroupAutoActivate == true or SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
					SortGroup_Method_SendSortOptionToSortBy(true);
				else
					SortGroup_Method_SendSortOptionToSortBy(false);
				end
			elseif ( SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
				print( SortGroup_Method_ColorPrint(L["Page2_AdditionalSwitchbtnSave_Error"]) );
			end
		end);
	
	Page2_AdditionalSwitchbtnDelete:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page2_AdditionalSwitchbtnDelete", "", 2);
			if ( SortGroup_Variable_raidProfilOnLoadIndex == 0 and SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter == 1 ) then
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
					print( SortGroup_Method_ColorPrint(L["Deleted_RaidProfile"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved), "option") );
				end
				SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = nil;
				SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = {};
			else
				SortGroup_Method_RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
					print( SortGroup_Method_ColorPrint(L["Deleted_RaidProfile"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved), "option") );
				end
				table.remove(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad, SortGroup_Variable_raidProfilOnLoadIndex);
			end
			SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter = SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter -1;
			UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");	
			Page2_AdditionalSwitchbtnDelete:Disable();
			Page2_AdditionalSwitchbtnSave:Disable();
			if ( SortGroup_Method_CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad) > 0 ) then
				Page2_AdditionalSwitchbtnReset:Enable();
			else
				Page2_AdditionalSwitchbtnReset:Disable();
			end
			SortGroup_Method_DisableSliders();
			SortGroup_Method_fillArray();
			SortGroup_Method_SaveOptions();
		end);
		
	Page2_AdditionalSwitchbtnReset:SetScript("OnClick",
		function()
			SortGroup_Method_Debug("Page2_AdditionalSwitchbtnReset", "", 2);
			StaticPopupDialogs["Show_Dialog_Reset"] = {
				text = L["Reset_RaidProfile_Dialog"],
				button1 = L["Reset_RaidProfile_Dialog_Yes"],
				button2 = L["Reset_RaidProfile_Dialog_No"],
				OnAccept = function()
					SortGroup_Method_Debug("Page2_AdditionalSwitchbtnReset", "Yes", 3);
					SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = nil;
					SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = {};	
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
					Page2_AdditionalSwitchbtnDelete:Disable();
					Page2_AdditionalSwitchbtnSave:Disable();
					Page2_AdditionalSwitchbtnReset:Disable();
					SortGroup_Method_DisableSliders();
					SortGroup_Method_fillArray();
					SortGroup_Method_SaveOptions();	
					if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
						print( SortGroup_Method_ColorPrint(L["Reset_RaidProfile_Dialog_accepted"], "option") );
					end
				end,
				timeout = 0,
				whileDead = true,
				hideOnEscape = true,
				preferredIndex = 3,
			}		
			StaticPopup_Show ("Show_Dialog_Reset");
		end);
	
	Page3_OptionsbtnReload:SetScript("OnClick",
		function()
			ReloadUI();
		end);
end

local function SliderEvent()
	SortGroup_Method_Debug("SliderEvent", "", 2);
	Page2_AdditionalSwitchSliderMinimum:SetScript("OnValueChanged",
		function()
			if ( (SortGroup_Variable_Page2_AdditionalSwitchraidProfile ~= nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved == nil) or  (SortGroup_Variable_Page2_AdditionalSwitchraidProfile == nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil) ) then				
				SortGroup_Method_UpdateSliders("Minimum");
				SortGroup_Method_Debug("SliderEvent", "Minimum Slider " .. Page2_AdditionalSwitchSliderMinimum:GetValue(), 3);
				if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil ) then
					SortGroup_Method_RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
					if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Minimum ==  math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) and SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Maximum ==  math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) then
						Page2_AdditionalSwitchbtnSave:Disable();
					else
						Page2_AdditionalSwitchbtnSave:Enable();
					end
				end
			end
		end);
		
	Page2_AdditionalSwitchSliderMaximum:SetScript("OnValueChanged",
		function()
			if ( (SortGroup_Variable_Page2_AdditionalSwitchraidProfile ~= nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved == nil) or  (SortGroup_Variable_Page2_AdditionalSwitchraidProfile == nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil) ) then
				SortGroup_Method_UpdateSliders("Maximum");
				SortGroup_Method_Debug("SliderEvent", "Maximum Slider " .. Page2_AdditionalSwitchSliderMaximum:GetValue(), 3);
				if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil ) then
					SortGroup_Method_RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
					if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Minimum ==  math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) and SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Maximum ==  math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) then
						Page2_AdditionalSwitchbtnSave:Disable();
					else
						Page2_AdditionalSwitchbtnSave:Enable();
					end
				end
			end	
		end);
end
---End Events

function SortGroup_Method_SortTopDownwards()
	SortGroup_Method_Debug("SortGroup_Method_SortTopDownwards", "", 2);
	--LoadAddOn("CompactRaidFrameContainer");
	local CRFSort_TopDownwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(CompactRaidFrameContainer, CRFSort_TopDownwards)
end

function SortGroup_Method_SortTopUpwards()
	SortGroup_Method_Debug("SortGroup_Method_SortTopUpwards", "", 2);
	--LoadAddOn("Blizzard_CompactRaidFrames");
	--LoadAddOn("CompactRaidFrameContainer");
	local CRFSort_TopUpwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(CompactRaidFrameContainer, CRFSort_TopUpwards)
end
	
function SortGroup_Method_SortBottomUpwards()
	SortGroup_Method_Debug("SortGroup_Method_SortBottomUpwards", "", 2);
	--LoadAddOn("CompactRaidFrameContainer");
	local CRFSort_BottomUpwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(CompactRaidFrameContainer, CRFSort_BottomUpwards)
end

function SortGroup_Method_SortBottomDownwards()
	SortGroup_Method_Debug("SortGroup_Method_SortBottomDownwards", "", 2);
	--LoadAddOn("CompactRaidFrameContainer");
	local CRFSort_BottomDownwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(CompactRaidFrameContainer, CRFSort_BottomDownwards)
end

function SortGroup_Method_SendSortOptionToSortBy(ExternSwitch)
	SortGroup_Method_Debug("SortGroup_Method_SendSortOptionToSortBy", "", 2);
	if ( SortGroup_Variable_RegardlessRaidProfile == false ) then
		if ( SortGroup_Variable_GroupTop == true or SortGroup_Variable_GroupBottom == true ) then
			if ( SortGroup_Method_ReadAllRaidProfiles(SortGroup_Variable_raidProfile) == false ) then
				if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
				cachePrintSendSortOptionToSortBy = L["RaidProfil_dont_exists"]:gsub("'replacement'", SortGroup_Variable_raidProfile);
				SortGroup_Variable_raidProfile = GetRaidProfileName(1);
					print(SortGroup_Method_ColorPrint(cachePrintSendSortOptionToSortBy:gsub("'replacement2'", SortGroup_Variable_raidProfile), "option"));
				end
				UIDropDownMenu_SetText(ddmProfiles, SortGroup_Variable_raidProfile);
			end
		end
	end
	if ( ExternSwitch == true ) then
		SortGroup_Method_SortBy("","", true);
	end
	if ( SortGroup_Variable_GroupTop == true ) then
		SortGroup_Method_SortBy('Down', SortGroup_Variable_raidProfile, false);
	elseif ( SortGroup_Variable_GroupBottom == true ) then
		SortGroup_Method_SortBy('Up', SortGroup_Variable_raidProfile, false);
	else
		if ( SortGroup_Variable_showChatMessage == true ) then
			if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
				print (SortGroup_Method_ColorPrint(L["sort_no"], "option"));
			end	
		end
	end
	SortGroup_Variable_showChatMessage = false;
end
-- Breakpoint between Methods and SortGroup_Method_SortBy

function SortGroup_Method_SortBy(SortOption, RaidProfileName, ExternSwitch)	
	SortGroup_Method_Debug("SortGroup_Method_SortBy", "", 2);
	if ( ExternSwitch == true ) then 
		SortGroup_Method_SwitchRaidProfiles();
	elseif ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
		if ( RaidProfileName ~= nil and GetNumGroupMembers() <= 5 and HasLoadedCUFProfiles() == true ) then
			if ( GetActiveRaidProfile() ~= RaidProfileName and SortGroup_Variable_GroupAutoActivate == false and SortGroup_Variable_RegardlessRaidProfile == false ) then
				if ( SortGroup_Variable_showChatMessage == true ) then
					if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
						print(SortGroup_Method_ColorPrint(L["RaidProfil_Doesnt_match"], "option"));
					end
				end
			elseif ( GetActiveRaidProfile() == RaidProfileName or SortGroup_Variable_RegardlessRaidProfile == true ) then
				if ( SortOption == 'Down') then
					if ( SortGroup_Variable_GroupTopDownwards == true ) then
						if ( SortGroup_Variable_showChatMessage == true ) then
							if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
								if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
									print(SortGroup_Method_ColorPrint(L["sort_top_downwards_regardless"], "option"));
								end
							else
								if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
									print(SortGroup_Method_ColorPrint(L["sort_top_downwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						SortGroup_Method_CheckRaidProfileOptions();
						SortGroup_Method_SortTopDownwards();
					end
					if ( SortGroup_Variable_GroupTopUpwards == true ) then
						if ( SortGroup_Variable_showChatMessage == true ) then
							if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
								if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
									print(SortGroup_Method_ColorPrint(L["sort_top_upwards_regardless"], "option"));
								end
							else
								if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
									print(SortGroup_Method_ColorPrint(L["sort_top_upwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						SortGroup_Method_CheckRaidProfileOptions();
						SortGroup_Method_SortTopUpwards();
					end
				elseif ( SortOption == 'Up') then
					if ( SortGroup_Variable_GroupBottomDownwards == true ) then
						if ( SortGroup_Variable_showChatMessage == true ) then
							if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
								if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
									print(SortGroup_Method_ColorPrint(L["sort_bottom_downwards_regardless"], "option"));
								end
							else
								if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
									print(SortGroup_Method_ColorPrint(L["sort_bottom_downwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						SortGroup_Method_CheckRaidProfileOptions();
						SortGroup_Method_SortBottomDownwards();
					end
					if ( SortGroup_Variable_GroupBottomUpwards == true ) then
						if ( SortGroup_Variable_showChatMessage == true ) then
							if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
								if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
									print(SortGroup_Method_ColorPrint(L["sort_bottom_upwards_regardless"], "option"));
								end
							else
								if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
									print(SortGroup_Method_ColorPrint(L["sort_bottom_upwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						SortGroup_Method_CheckRaidProfileOptions();
						SortGroup_Method_SortBottomUpwards();
					end
				end
			end	
		end
	end
end
-- Final desicion, which Raid Profile gets loaded and which Sort Method will be used

function SortGroup_Method_CheckRaidProfileOptions()
	SortGroup_Method_Debug("SortGroup_Method_CheckRaidProfileOptions", "", 2);
	if ( GetNumGroupMembers() <= 5 ) then
		if ( CompactUnitFrameProfilesRaidStylePartyFrames:GetChecked() == false ) then
			CompactUnitFrameProfilesRaidStylePartyFrames:Click("LeftButton",true);
			SortGroup_Method_Debug("SortGroup_Method_CheckRaidProfileOptions", "RaidStylePartyFrames clicked", 3);
		end
		if ( CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:GetChecked() == true ) then
			--CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click();
			--taints if activated - need to make a work around
			if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true and SortGroup_Variable_showChatMessage == true ) then
			
				print(SortGroup_Method_ColorPrint(L["Keep_Group_Together_Active"], "option"));
			end
			SortGroup_Method_Debug("SortGroup_Method_CheckRaidProfileOptions", "KeepGroupsTogether checked", 3);
		end
	end
end
--necessary changes, otherwise there is no sort
--CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether taints, so User needs to do this

function SortGroup_Method_ReadAllRaidProfiles(SortGroup_Variable_raidProfile)
	SortGroup_Method_Debug("SortGroup_Method_ReadAllRaidProfiles", "", 2);
	local raidprofilexists = false;
	SortGroup_Variable_ddmItems = nil;
	SortGroup_Variable_ddmItems = {};
	for i=1, GetNumRaidProfiles(), 1 do
		SortGroup_Variable_ddmItems[i] = GetRaidProfileName(i);
		if ( SortGroup_Variable_ddmItems[i] == SortGroup_Variable_raidProfile ) then
			raidprofilexists = true;
			
		end
	end
	if ( raidprofilexists == true ) then
		SortGroup_Method_Debug("SortGroup_Method_ReadAllRaidProfiles", SortGroup_Variable_raidProfile .. " exists", 3);
		return true;
	else
		SortGroup_Method_Debug("SortGroup_Method_ReadAllRaidProfiles", "doesn't exists", 3);
	end
	return false;
end
--Fills SortGroup_Variable_ddmItems with raidprofiles and checks if raidprofil exists

function SortGroup_Method_UpdateComboBoxes()
	SortGroup_Method_Debug("SortGroup_Method_UpdateComboBoxes", "", 2);
	if ( SortGroup_Variable_GroupAutoActivate == true ) then
		cbAutoActivate:SetChecked(true);
		getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbAutoActivate_Option_Text"],"white"));
	else
		cbAutoActivate:SetChecked(false);
	end
	
	if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
		--SortGroup_Variable_cacheAutoActive = AutoActivate;
		--AutoActivate = false;
		UIDropDownMenu_DisableDropDown(ddmProfiles);
		cbAutoActivate:Disable();
		getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbAutoActivate_Option_Text"],"disable"));
		cbRegardlessRaidProfile:SetChecked(true);
	else
		SortGroup_Variable_RegardlessRaidProfile = false;
		--AutoActivate = SortGroup_Variable_cacheAutoActive;
		cbAutoActivate:Enable();
		getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbAutoActivate_Option_Text"], "white"));
		if ( cbAutoActivate:GetChecked() == true ) then
			UIDropDownMenu_EnableDropDown(ddmProfiles);
		end
		cbRegardlessRaidProfile:SetChecked(false);
	end
	
	if ( SortGroup_Variable_GroupTop == true ) then
		cBTop:SetChecked(true);
		cBBottom:SetChecked(false);
		cbTopDownwards:Enable();
		cbTopUpwards:Enable();
		cbBottomDownwards:Disable();
		cbBottomUpwards:Disable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbDownwards_Option_Text"], "white"));
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbUpwards_Option_Text"], "white"));
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbUpwards_Option_Text"],"disable"));
	elseif ( SortGroup_Variable_GroupBottom == true ) then
		cBTop:SetChecked(false);
		cBBottom:SetChecked(true);
		cbTopDownwards:Disable();
		cbTopUpwards:Disable();
		cbBottomDownwards:Enable();
		cbBottomUpwards:Enable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbUpwards_Option_Text"],"disable"));
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbDownwards_Option_Text"], "white"));
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbUpwards_Option_Text"], "white"));
	else
		cBTop:SetChecked(false);
		cBBottom:SetChecked(false);
		cbTopDownwards:Disable();
		cbTopUpwards:Disable();
		cbBottomDownwards:Disable();
		cbBottomUpwards:Disable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbUpwards_Option_Text"],"disable"));
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["cbUpwards_Option_Text"],"disable"));
	end
	
	if ( SortGroup_Variable_GroupTopDownwards == true ) then
		cbTopDownwards:SetChecked(true);
		cbTopUpwards:SetChecked(false);
	elseif ( SortGroup_Variable_GroupTopUpwards == true ) then
			cbTopDownwards:SetChecked(false);
			cbTopUpwards:SetChecked(true);
	else 	
		cbTopDownwards:SetChecked(false);
		cbTopUpwards:SetChecked(false);
	end
	if ( SortGroup_Variable_GroupBottomDownwards == true ) then
		cbBottomDownwards:SetChecked(true);
		cbBottomUpwards:SetChecked(false);
	elseif ( SortGroup_Variable_GroupBottomUpwards == true ) then
		cbBottomDownwards:SetChecked(false);
		cbBottomUpwards:SetChecked(true);
	else
		cbBottomDownwards:SetChecked(false);
		cbBottomUpwards:SetChecked(false);
	end
	
	if ( SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
		Page2_AdditionalSwitchcbActive:SetChecked(true);
		UIDropDownMenu_EnableDropDown(Page2_AdditionalSwitchddmProfiles);
		if ( SortGroup_Method_CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad) > 0 ) then
			Page2_AdditionalSwitchbtnReset:Enable();
		else
			Page2_AdditionalSwitchbtnReset:Disable();
		end
	else
		UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
		Page2_AdditionalSwitchcbActive:SetChecked(false);
		UIDropDownMenu_DisableDropDown(Page2_AdditionalSwitchddmProfiles);
		SortGroup_Method_DisableSliders();
	end
	if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfile == nil ) then
		SortGroup_Method_DisableSliders();
	end
	
	if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
		Page3_cbChatMessagesOn:SetChecked(true);
		Page3_cbChatMessagesCurrentOptions:Enable();
		Page3_cbChatMessagesRaidProfileSwitch:Enable();
		Page3_cbChatMessagesWarnings:Enable();
		getglobal(Page3_cbChatMessagesCurrentOptions:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesCurrentOptions_Option_Text"], "white"));
		getglobal(Page3_cbChatMessagesRaidProfileSwitch:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesRaidProfileSwitch_Option_Text"], "white"));
		getglobal(Page3_cbChatMessagesWarnings:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_ChatMessagesWarnings_Option_Text"], "white"));

	else 
		Page3_cbChatMessagesOn:SetChecked(false);
		Page3_cbChatMessagesCurrentOptions:Disable();
		Page3_cbChatMessagesRaidProfileSwitch:Disable();
		Page3_cbChatMessagesWarnings:Disable();
		getglobal(Page3_cbChatMessagesCurrentOptions:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesCurrentOptions_Option_Text"], "disable"));
		getglobal(Page3_cbChatMessagesRaidProfileSwitch:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbChatMessagesRaidProfileSwitch_Option_Text"], "disable"));
		getglobal(Page3_cbChatMessagesWarnings:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_ChatMessagesWarnings_Option_Text"], "disable"));
	end
	if ( SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
		Page3_cbChatMessagesCurrentOptions:SetChecked(true);
	else
		Page3_cbChatMessagesCurrentOptions:SetChecked(false);
	end
	if ( SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch == true ) then
		Page3_cbChatMessagesRaidProfileSwitch:SetChecked(true);
	else
		Page3_cbChatMessagesRaidProfileSwitch:SetChecked(false);
	end
	if ( SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
		Page3_cbChatMessagesWarnings:SetChecked(true);
	else
		Page3_cbChatMessagesWarnings:SetChecked(false);
	end
	if ( SortGroup_Variable_Page3_ChangesInCombat == true ) then
		Page3_cbChangesInCombat:SetChecked(true);
	else
		Page3_cbChangesInCombat:SetChecked(false);
	end
	if ( SortGroup_Variable_Page3_RaidProfilesUpdateInCombat == true ) then
		Page3_cbRaidProfilesUpdateInCombat:SetChecked(true);
		Page3_cbRaidProfilesUpdateInCombatVisibility:Disable();
		getglobal(Page3_cbRaidProfilesUpdateInCombatVisibility:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_RaidProfilesUpdateInCombatVisibility_Option_Text"],"disable"));
	else
		Page3_cbRaidProfilesUpdateInCombat:SetChecked(false);
		Page3_cbRaidProfilesUpdateInCombatVisibility:Enable();
		getglobal(Page3_cbRaidProfilesUpdateInCombatVisibility:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_RaidProfilesUpdateInCombatVisibility_Option_Text"],"white"));
	end
	if ( SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility == true ) then
		Page3_cbRaidProfilesUpdateInCombatVisibility:SetChecked(true);
	else
		Page3_cbRaidProfilesUpdateInCombatVisibility:SetChecked(false);
	end
	if ( SortGroup_Variable_Page3_RaidProfilesSwitchInCombat == true ) then
		Page3_cbRaidProfilesSwitchInCombat:SetChecked(true);
	else
		Page3_cbRaidProfilesSwitchInCombat:SetChecked(false);
	end
	if ( SortGroup_Variable_Page3_Options_DebugMode == false ) then
		Page3_cbDebugMode:SetChecked(false);
		Page3_cbDebugModeLevel1:Disable();
		Page3_cbDebugModeLevel2:Disable();
		Page3_cbDebugModeLevel3:Disable();
		getglobal(Page3_cbDebugModeLevel1:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel1_Option_Text"],"disable"));
		getglobal(Page3_cbDebugModeLevel2:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel2_Option_Text"],"disable"));
		getglobal(Page3_cbDebugModeLevel3:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel3_Option_Text"],"disable"));
		SortGroup_Variable_debuglevel = 0;
	else
		Page3_cbDebugMode:SetChecked(true);
		Page3_cbDebugModeLevel1:Enable();
		Page3_cbDebugModeLevel2:Enable();
		Page3_cbDebugModeLevel3:Enable();
		getglobal(Page3_cbDebugModeLevel1:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel1_Option_Text"], "white"));
		getglobal(Page3_cbDebugModeLevel2:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel2_Option_Text"], "white"));
		getglobal(Page3_cbDebugModeLevel3:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(L["Page3_cbDebugModeLevel3_Option_Text"], "white"));
		SortGroup_Variable_debuglevel = 0;
		if( SortGroup_Variable_Page3_Options_DebugModeLevel1 == true ) then
			Page3_cbDebugModeLevel1:SetChecked(true);
			SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 1;	
		end
		if( SortGroup_Variable_Page3_Options_DebugModeLevel2 == true ) then
			Page3_cbDebugModeLevel2:SetChecked(true);
			SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 2;
		end
		if( SortGroup_Variable_Page3_Options_DebugModeLevel3 == true ) then
			Page3_cbDebugModeLevel3:SetChecked(true);
			SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 4;
		end
	end
	if( SortGroup_Variable_Page3_Options_DebugModeLevel1 == true ) then
		Page3_cbDebugModeLevel1:SetChecked(true);
	else
		Page3_cbDebugModeLevel1:SetChecked(false);
	end
	if( SortGroup_Variable_Page3_Options_DebugModeLevel2 == true ) then
		Page3_cbDebugModeLevel2:SetChecked(true);
	else
		Page3_cbDebugModeLevel2:SetChecked(false);
	end
	if( SortGroup_Variable_Page3_Options_DebugModeLevel3 == true ) then
		Page3_cbDebugModeLevel3:SetChecked(true);
	else
		Page3_cbDebugModeLevel3:SetChecked(false);
	end
end
-- Updating all displayed elements

function SortGroup_Method_DisableSliders()
	SortGroup_Method_Debug("SortGroup_Method_DisableSliders", "", 2);
	Page2_AdditionalSwitchSliderMinimum:Disable();
	Page2_AdditionalSwitchSliderMaximum:Disable();
	Page2_AdditionalSwitchbtnSave:Disable();
	Page2_AdditionalSwitchbtnDelete:Disable();
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText(SortGroup_Method_ColorPrint('1', "disable"));
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText(SortGroup_Method_ColorPrint('40', "disable"));
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()), "disable"));
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText(SortGroup_Method_ColorPrint('1', "disable"));
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText(SortGroup_Method_ColorPrint('40', "disable"))
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText(SortGroup_Method_ColorPrint(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()), "disable"));
end

function SortGroup_Method_UpdateSliders(option,index)
	SortGroup_Method_Debug("SortGroup_Method_UpdateSliders", "", 2);
	cacheProfileColorSliders = nil
	if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil ) then
		cacheProfileColorSliders = SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved;
	else
		cacheProfileColorSliders = SortGroup_Variable_Page2_AdditionalSwitchraidProfile;
	end
	if ( option == "Minimum" ) then
		if ( ( math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) ) <= ( math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ) ) then
			SortGroup_Method_Debug("SortGroup_Method_UpdateSliders", "Minimum <= Maximum", 3);
			if ( SortGroup_Method_MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())) == false ) then
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "green" ));
			elseif ( SortGroup_Method_ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "green" ));
			else
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "red" ));
			end
		else
			SortGroup_Method_Debug("SortGroup_Method_UpdateSliders", "Minimum > Maximum", 3);
			Page2_AdditionalSwitchSliderMinimum:SetValue(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()));
			if ( SortGroup_Method_MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())) == false ) then
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())  ), "green" ));
			elseif ( SortGroup_Method_ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then				
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) ), "green" ));
			else
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())  ), "red" ));
			end
		end
	elseif ( option == "Maximum" ) then
		if ( ( math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ) >= ( math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) ) ) then
			SortGroup_Method_Debug("SortGroup_Method_UpdateSliders", "Minimum <= Maximum", 3);
			if ( SortGroup_Method_MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) == false ) then
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "green" ));
			elseif ( SortGroup_Method_ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "green" ));
			else
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "red" ));
			end
		else
			SortGroup_Method_Debug("SortGroup_Method_UpdateSliders", "Minimum > Maximum", 3);
			Page2_AdditionalSwitchSliderMaximum:SetValue(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()));
			if ( SortGroup_Method_MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) == false ) then
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ), "green" ));
			elseif ( SortGroup_Method_ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ), "green" ));
			else
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ), "red" ));
			end
		end
	elseif ( option == "ddmProfiles" ) then
		if ( SortGroup_Method_MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())) == false ) then
			getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "green" ));
		else
			getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "red" ));
		end
		if ( SortGroup_Method_MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) == false ) then
			getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "green" ));
		else
			getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "red" ));
		end
	elseif ( option == "ddmSelectedProfiles" ) then
		Page2_AdditionalSwitchSliderMinimum_Text:SetValue( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[index].Minimum );
		Page2_AdditionalSwitchSliderMaximum_Text:SetValue( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[index].Maximum );
		getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[index].Minimum, "green" ));
		getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( SortGroup_Method_ColorPrint(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[index].Maximum, "green" ));
	end
end
-- Method to only color sliders
	
function SortGroup_Method_resetRaidContainer()	
	if ( SortGroup_Variable_Page3_RaidProfilesUpdateInCombat == false ) then
		SortGroup_Method_Debug("SortGroup_Method_resetRaidContainer", "", 2);
		local old_CompactRaidFrameContainer_TryUpdate = CompactRaidFrameContainer_TryUpdate
		CompactRaidFrameContainer_TryUpdate = function(self)	
			if ( SortGroup_Variable_inCombat == true ) then
				SortGroup_Variable_CompactSave[self:GetName()] = "CompactRaidFrameContainer_TryUpdate"
			else
				old_CompactRaidFrameContainer_TryUpdate(self)
			end
		end
		
		local old_CompactRaidGroup_UpdateUnits = CompactRaidGroup_UpdateUnits
		CompactRaidGroup_UpdateUnits = function(self)
			if ( SortGroup_Variable_inCombat == true ) then
				SortGroup_Variable_CompactSave[self:GetName()] = "CompactRaidGroup_UpdateUnits"
			else
				old_CompactRaidGroup_UpdateUnits(self)
			end
		end
		
		--[[
		hooksecurefunc("CompactUnitFrame_UpdateAll", function(self)
			if ( SortGroup_Variable_inCombat == true ) then
				SortGroup_Variable_CompactSave[self:GetName()] = "CompactUnitFrame_UpdateAll"
			end
		end)
		--]]
		
		if ( SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility == true ) then
			local old_CompactUnitFrame_UpdateInRange = CompactUnitFrame_UpdateInRange
			hooksecurefunc("CompactUnitFrame_UpdateInRange", function(self)
				if not UnitExists(self.displayedUnit) then
					self:SetAlpha(0.1);
				else
					old_CompactUnitFrame_UpdateInRange(self);
				end
			end)
		end
		
	end
end
-- For updating after combat fades

function SortGroup_Method_ColorPrint(text, operation)
	if ( operation == "option" ) then
		cacheText = text:gsub("SortGroup:" , function(cap)
			cap = cap:sub(1, -1);
			local color = "|cff00FF7F" or defaultColor;
			return color..cap.."|r";
		end)
		return cacheText;
	elseif ( operation == "disable" ) then
		local color = "|cff888888" or defaultColor;
		return color..text;
	elseif ( operation == "green" ) then
		local color = "|cff00ff00" or defaultColor;
		return color..text;
	elseif ( operation == "red" ) then
		local color = "|cffff0000" or defaultColor;
		return color..text;
	elseif ( operation == "white" ) then
		local color = "|cffffffff" or defaultColor;
		return color..text;
	end
end
-- Color everything expcept sliders

function SortGroup_Method_CountTable(t)
	SortGroup_Method_Debug("SortGroup_Method_CountTable", "", 2);
	local count = 0
	for _ in pairs(t) do 
		count = count + 1 
	end
	return count;
end

function SortGroup_Method_RaidProfilOnLoadExists(raidProfilOnLoad)
	SortGroup_Method_Debug("SortGroup_Method_RaidProfilOnLoadExists", "", 2);
	local cacheCountTable = SortGroup_Method_CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad);
	if ( cacheCountTable > 0 ) then
		for i = 1, cacheCountTable, 1 do
			if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i] ~= nil ) then
				if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName == raidProfilOnLoad ) then
					SortGroup_Variable_raidProfilOnLoadIndex = i;
					SortGroup_Method_Debug("SortGroup_Method_RaidProfilOnLoadExists", i .. " exists", 3);
					return true;
				else	
					SortGroup_Method_Debug("SortGroup_Method_RaidProfilOnLoadExists", i .. " doesn't exist", 3);
				end
			end
		end
	end
	return false;
end
--  Checks if RaidProfil is in List

function SortGroup_Method_DeleteRaidProfileNotExists()
	SortGroup_Method_Debug("SortGroup_Method_DeleteRaidProfileNotExists", "", 2);
	local cacheCountTable = SortGroup_Method_CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad);
	if ( cacheCountTable > 0 ) then
		for i = 1, cacheCountTable, 1 do
			if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i] ~= nil ) then
				if ( SortGroup_Method_ReadAllRaidProfiles(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName) == false ) then
					if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
						print( SortGroup_Method_ColorPrint(L["Deleted_RaidProfile_Not_Exists"]:gsub("'replacement'", (SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName)), "option") );
					end
					SortGroup_Method_Debug("SortGroup_Method_DeleteRaidProfileNotExists", (SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName .. " deleted"), 3 );
					table.remove(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad, i);	
					Page2_AdditionalSwitchbtnDelete:Disable();
					Page2_AdditionalSwitchbtnSave:Disable();
					SortGroup_Method_DisableSliders();
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");	
				end
			end
		end
	end
	SortGroup_Method_fillArray();
end
-- not existing RaidProfiles get deleted from list

function SortGroup_Method_SwitchRaidProfiles()
	SortGroup_Method_Debug("SortGroup_Method_SwitchRaidProfiles", "", 2);
	if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
		SortGroup_Method_DeleteRaidProfileNotExists();
		member = tonumber(GetNumGroupMembers());
		if ( member == 0 ) then
			member = 1;
		end
		if ( HasLoadedCUFProfiles() == true ) then
			if ( SortGroup_Variable_Page2_AdditionalSwitchArray[member][0] == true and SortGroup_Variable_Page2_AdditionalSwitchArray[member][1] ~= "" ) then
				if ( GetActiveRaidProfile() ~= SortGroup_Variable_Page2_AdditionalSwitchArray[member][1] and ( SortGroup_Variable_Page2_AdditionalSwitchActive == true or SortGroup_Variable_GroupAutoActivate == true ) ) then	
					if ( SortGroup_Variable_Page3_RaidProfilesSwitchInCombat == true or SortGroup_Variable_inCombat == false ) then
						SortGroup_Method_ExecuteSwitchRaidProfiles(SortGroup_Variable_Page2_AdditionalSwitchArray[member][1]);
						if ( SortGroup_Variable_Page3_chatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch == true ) then
							print( SortGroup_Method_ColorPrint(L["RaidProfil_changed"]:gsub("'replacement'", (SortGroup_Variable_Page2_AdditionalSwitchArray[member][1])), "option") );
						end
						SortGroup_Method_Debug("SortGroup_Method_SwitchRaidProfiles", "SortGroup_Variable_Page2_AdditionalSwitchActive = true", 3);
					end
				end	
			end
		end
	end
end
-- Possible switch by Group_Roster, OK button, COMPACT_UNIT_FRAME_PROFILES_LOADED, PLAYER_REGEN_ENABLED, cbAutoActivate or ddmProfiles
-- Cancel Button caused taint 

function SortGroup_Method_ExecuteSwitchRaidProfiles(profile)
	SortGroup_Method_Debug("SortGroup_Method_ExecuteSwitchRaidProfiles", "", 2);
	SortGroup_Method_Debug("SortGroup_Method_ExecuteSwitchRaidProfiles", "to profile: " .. profile, 3);
	CompactUnitFrameProfiles.selectedProfile = profile;
	SaveRaidProfileCopy(profile);
	SetCVar("activeCUFProfile", profile);
	UIDropDownMenu_SetSelectedValue(CompactUnitFrameProfilesProfileSelector, profile);
	UIDropDownMenu_SetText(CompactUnitFrameProfilesProfileSelector, profile);	
	UIDropDownMenu_SetSelectedValue(CompactRaidFrameManagerDisplayFrameProfileSelector, profile);
	UIDropDownMenu_SetText(CompactRaidFrameManagerDisplayFrameProfileSelector, profile);		
	CompactUnitFrameProfiles_ApplyCurrentSettings();
	--CompactUnitFrameProfiles_UpdateCurrentPanel();
	--Taint - Disabled
	CompactUnitFrameProfiles_HidePopups();
end
-- CompactUnitFrameProfiles_UpdateCurrentPanel will cause taint because of the sort inject. 
-- So CompactUnitFrameProfiles_ActivateRaidProfile can only be activated by the user without taint

function SortGroup_Method_fillArray()
	SortGroup_Method_Debug("SortGroup_Method_fillArray", "", 2);
	for i = 1, 40, 1 do
		SortGroup_Variable_Page2_AdditionalSwitchArray[i] = {};
		if ( SortGroup_Variable_GroupAutoActivate == true and SortGroup_Variable_RegardlessRaidProfile == false and i <= 5 ) then
			SortGroup_Variable_Page2_AdditionalSwitchArray[i][0] = true;
			SortGroup_Variable_Page2_AdditionalSwitchArray[i][1] = SortGroup_Variable_raidProfile;
			SortGroup_Method_Debug("SortGroup_Method_fillArray", ("Index " .. i .. " true"), 3);
		else
			SortGroup_Variable_Page2_AdditionalSwitchArray[i][0] = false;
			SortGroup_Variable_Page2_AdditionalSwitchArray[i][1] = "";
			SortGroup_Method_Debug("SortGroup_Method_fillArray", ("Index " .. i .. " false"), 3);
		end
	end
	local cacheCountTable = SortGroup_Method_CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad);
	if ( cacheCountTable > 0 ) then
		for i = 1, cacheCountTable, 1 do
			for c = (tonumber(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Minimum)), (tonumber(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Maximum)), 1 do
				if ( (SortGroup_Variable_GroupAutoActivate == true and c > 5) or SortGroup_Variable_GroupAutoActivate == false ) then
					if ( SortGroup_Variable_Page2_AdditionalSwitchArray[c] ~= nil ) then
						SortGroup_Variable_Page2_AdditionalSwitchArray[c][0] = true;
						SortGroup_Variable_Page2_AdditionalSwitchArray[c][1] = SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName;
					elseif ( SortGroup_Variable_Page2_AdditionalSwitchArray[c] == nil ) then
						SortGroup_Method_Debug("SortGroup_Method_fillArray", nil, 3);
					end
					if ( SortGroup_Variable_Page2_AdditionalSwitchArray[c][0] == true ) then
						SortGroup_Method_Debug("SortGroup_Method_fillArray", ("Index " .. c .. " true"), 3);
					else
						SortGroup_Method_Debug("SortGroup_Method_fillArray", ("Index " .. c .. " false"), 3);
					end
				elseif ( SortGroup_Variable_GroupAutoActivate == true and c <= 5 ) then
					SortGroup_Variable_Page2_AdditionalSwitchArray[c][0] = true;
					SortGroup_Variable_Page2_AdditionalSwitchArray[c][1] = SortGroup_Variable_raidProfile;
					if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Minimum <= 5 ) then
					SortGroup_Method_Debug("SortGroup_Method_fillArray", ("RaidProfil: " .. SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName .. " Minimum: " .. SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Minimum .. " deleted"), 3);
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Minimum = 6;
					end
					if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Maximum <= 6 ) then
						SortGroup_Method_Debug("SortGroup_Method_fillArray", ("RaidProfil: " .. SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName .. "Maximum: " .. SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Maximum .. " deleted"), 3);
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Maximum = 7; 
					end
				end
			end
		end
	end
end
-- Update Array with updated RaidProfil List

function SortGroup_Method_ElementIsInArray(Minimum, Maximum)
	SortGroup_Method_Debug("SortGroup_Method_ElementIsInArray","", 2)
	for i = (tonumber(Minimum)), (tonumber(Maximum)), 1 do
		if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i] ~= nil ) then	
			if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i][0] == true ) then
				SortGroup_Method_Debug("SortGroup_Method_ElementIsInArray", ("Index " .. i .. " SortGroup_Variable_Page2_AdditionalSwitchArray[i][1]"));
				return SortGroup_Variable_Page2_AdditionalSwitchArray[i][1];
			end
		else
			SortGroup_Method_Debug("SortGroup_Method_ElementIsInArray",nil, 3)
		end
	end
	return nil;
end
-- Checks if no Raid Profils are in a specific Group Size

function SortGroup_Method_MinMaxInArray(MinMax)
	SortGroup_Method_Debug("SortGroup_Method_MinMaxInArray", "", 2);
	if ( SortGroup_Variable_Page2_AdditionalSwitchArray[MinMax] ~= nil ) then
		if ( SortGroup_Variable_Page2_AdditionalSwitchArray[MinMax][0] == true ) then
			SortGroup_Method_Debug("SortGroup_Method_MinMaxInArray", true, 3);
			return true;
		else
			SortGroup_Method_Debug("SortGroup_Method_MinMaxInArray", false, 3);
			return false;
		end
	end
end
--Minimum Maximum check, true if exists

function SortGroup_Method_ElementChangeOwnElement(Minimum, Maximum, raidProfilOnLoad)
	SortGroup_Method_Debug("SortGroup_Method_ElementChangeOwnElement", "", 2)
	OwnElement = true;
	for i = (tonumber(Minimum)), (tonumber(Maximum)), 1 do
		if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i] ~= nil ) then
			if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i][0] == true ) then
				if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i][1] ~= raidProfilOnLoad ) then
					SortGroup_Variable_Page2_AdditionalSwitchraidProfilOnThatPlace = SortGroup_Variable_Page2_AdditionalSwitchArray[i][1];
					OwnElement = false;
				end
			end
		else
			OwnElement = nil;
		end
	end
	SortGroup_Method_Debug("SortGroup_Method_ElementChangeOwnElement", OwnElement, 3)
	return OwnElement;
end
-- true if Raid Profile gets resized in own area


function SortGroup_Method_SaveOptions()
	SortGroup_Method_Debug("SortGroup_Method_SaveOptions", "", 2);
	SortGroupInformation.Down = SortGroup_Variable_GroupTop;
	SortGroupInformation.Up = SortGroup_Variable_GroupBottom;
	SortGroupInformation.TopDownwards = SortGroup_Variable_GroupTopDownwards;
	SortGroupInformation.TopUpwards	= SortGroup_Variable_GroupTopUpwards;
	SortGroupInformation.BottomDownwards = SortGroup_Variable_GroupBottomDownwards;
	SortGroupInformation.BottomUpwards = SortGroup_Variable_GroupBottomUpwards;
	SortGroupInformation.Profile = SortGroup_Variable_raidProfile;
	SortGroupInformation.AutoActivate = SortGroup_Variable_GroupAutoActivate;
	SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile = SortGroup_Variable_RegardlessRaidProfile;
	SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive = SortGroup_Variable_Page2_AdditionalSwitchActive;
	SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn = SortGroup_Variable_Page3_chatMessagesOn;
	SortGroupInformation.SortGroup_Variable_Page3_chatMessagesCurrentOptions = SortGroup_Variable_Page3_chatMessagesCurrentOptions;
	SortGroupInformation.SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch = SortGroup_Variable_Page3_chatMessagesRaidProfileSwitch;
	SortGroupInformation.SortGroup_Variable_Page3_ChatMessagesWarnings = SortGroup_Variable_Page3_ChatMessagesWarnings;
	SortGroupInformation.RaidProfileOnLoad = SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad;
	SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = SortGroup_Variable_Page3_RaidProfilesUpdateInCombat;
	SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility = SortGroup_Variable_Page3_RaidProfilesUpdateInCombatVisibility;
	SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesSwitchInCombat = SortGroup_Variable_Page3_RaidProfilesSwitchInCombat;
	SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat = SortGroup_Variable_Page3_ChangesInCombat;
	SortGroupInformation.SortGroup_Variable_Page3_Options_DebugMode = SortGroup_Variable_Page3_Options_DebugMode;
	SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel1 = SortGroup_Variable_Page3_Options_DebugModeLevel1;
	SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel2 = SortGroup_Variable_Page3_Options_DebugModeLevel2;
	SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel3 = SortGroup_Variable_Page3_Options_DebugModeLevel3;
end
-- If client crashes, still all saved

function SortGroup_Method_Debug(methodName, methodContent, methodLevel)
	if ( SortGroup_Variable_Page3_Options_DebugMode == true ) then
	SortGroup_Variable_debugLevelCache = SortGroup_Variable_debuglevel;
		if ( SortGroup_Variable_debugLevelCache % 2 == 1 and methodLevel >= 1 ) then
			SortGroup_Variable_debugLevelCache = SortGroup_Variable_debugLevelCache - 1;
			if ( methodLevel == 1 ) then
				SortGroup_Variable_debugMethodNamePrint = true;
				print(SortGroup_Method_ColorPrint("SortGroup: Debuging - Options", "option"));
				print("'SortGroup_Variable_GroupTop' " .. tostring(SortGroup_Variable_GroupTop));
				print("'SortGroup_Variable_GroupTopDownwards' " .. tostring(SortGroup_Variable_GroupTopDownwards));
				print("'SortGroup_Variable_GroupTopUpwards' " .. tostring(SortGroup_Variable_GroupTopUpwards));
				print("'SortGroup_Variable_GroupBottom' " .. tostring(SortGroup_Variable_GroupBottom));
				print("'SortGroup_Variable_GroupBottomDownwards' " .. tostring(SortGroup_Variable_GroupBottomDownwards));
				print("'Profile' " .. tostring(SortGroup_Variable_raidProfile));
				print("'SortGroup_Variable_GroupAutoActivate' " .. tostring(SortGroup_Variable_GroupAutoActivate));
				print("'SortGroup_Variable_RegardlessRaidProfile' " .. tostring(SortGroup_Variable_RegardlessRaidProfile));
				print("'SortGroup_Variable_Page3_chatMessagesOn' " .. tostring(SortGroup_Variable_Page3_chatMessagesOn));
				print("'SortGroup_Variable_Page2_AdditionalSwitchActive' " .. tostring(SortGroup_Variable_Page2_AdditionalSwitchActive));
				print("'RaidProfileOnLoad' " .. tostring(RaidProfileOnLoad));
				print("'SortGroup_Variable_Page3_ChangesInCombat' " .. tostring(SortGroup_Variable_Page3_ChangesInCombat));
				print("'SortGroup_Variable_Page3_RaidProfilesUpdateInCombat' " .. tostring(SortGroup_Variable_Page3_RaidProfilesUpdateInCombat));
			end
		end
		if ( ( SortGroup_Variable_debugLevelCache == 2 or SortGroup_Variable_debugLevelCache == 6 ) and methodLevel >= 2 ) then
			if ( SortGroup_Variable_debugMethodNameCache ~= methodName ) then
				if ( SortGroup_Variable_debugMethodNamePrint == true ) then
					print(SortGroup_Method_ColorPrint("SortGroup: Debuging - Method Names", "option"));
					SortGroup_Variable_debugMethodNamePrint = false;
				end
				print("'" ..  methodName .. "()'");
				SortGroup_Variable_debugMethodNameCache = methodName;
			end
		end
		if ( SortGroup_Variable_debugLevelCache >= 4 and methodLevel == 3 ) then
			SortGroup_Variable_debugMethodNamePrint = true;
			if ( SortGroup_Variable_debugMethodContentCache ~= methodName ) then
				print(SortGroup_Method_ColorPrint("SortGroup: Debuging - Method content", "option"));	
			end
			SortGroup_Variable_debugMethodContentCache = methodName;
			print( "'" .. methodName .. "()' " .. tostring(methodContent));
		end		
	end
end
-- SortGroup_Method_Debug, goes through everything

local loader = CreateFrame("Frame")
loader:RegisterEvent("ADDON_LOADED")
loader:SetScript("OnEvent", function(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "SortGroup" then
		SortGroup_Method_Debug("StartAddon", "", 2);
		createFrame();
		createText();
		createCheckbox();
		createButton();
		createDropDownMenu();
		createSliders();
		frameEvent();	
		checkBoxEvent();
		buttonEvent();
		SliderEvent();
		self:UnregisterEvent("ADDON_LOADED")
	end
end)